  module snf_progno3

      subroutine rsnfout(vibf,normm,natoms,irrep)
*
* read file snf.out
*
* written by J. Neugebauer, Uni Erlangen, 2002
*
      implicit none
      integer i,j,natoms,nvar,nm2o,lu
      integer ka,kb,kc,min0,nc,la,lb,nr,lc
      real*8 vibf(natoms*3),normm(natoms*3,natoms*3)
      real*8 irrep(3*natoms)
      character*255 row
      character*4 symtxt
      nvar=3*natoms
      nm2o=6
      lu=1
      call testfile('snf.out')
      open(unit=lu,file='snf.out')
100   read(lu,'(A)',end=999) row
      if(index(row,'linear molecule').ne.0) nm2o=5
      if(index(row,'Infrared intensities').eq.0) goto 100
      do i=1,5
        read(lu,'(A)',end=999) row
      end do
      call clean(symtxt)
      do i=1,nm2o
        read(symtxt,'(A4)') irrep(i)
      end do
      do i=nm2o+1,nvar
        read(lu,'(A)') row
        read(row(11:14),'(A4)') symtxt
        read(symtxt,'(a4)') irrep(i)
      end do
200   read(lu,'(A)',end=999) row
      if(index(row,'root no.').eq.0) goto 200
      nr=nvar
      nc=nvar-nm2o
      ka=1
      kc=6
60    kb=min0(kc,nc)
      read(lu,'(A)',end=999) row
      read(lu,'(A)',end=999) row
      read(row,*) (vibf(nm2o+i),i=ka,kb)
      read(lu,'(A)',end=999) row
      la=1
      lc=40
70    lb=min0(lc,nr)
      do i=la,lb
        read(lu,'(A)',end=999) row
        read(row,130) (normm(i,nm2o+j),j=ka,kb)
      end do
      if(lb.eq.nr) goto 90
      la=lc+1
      lc=lc+40
      read(lu,'(A)',end=999) row
      go to 70
90    if (kb.eq.nc) goto 999
      ka=kc+1
      kc=kc+6
      if (nr.gt.25) read(lu,'(A)',end=999) row
      do i=1,5
        read(lu,'(A)',end=999) row
      end do
      goto 60

999   close(lu)
130   format(10x,f10.5,5f12.5)
      end

!******************************************************************
      subroutine displacecoord(coord,normmod,natoms,co,ic,nmno,dco,
     * cstep,ipre,maxnbm)
*----------------------------------------------------------------------|
* generation of coord-files for structures displaced along
* the normal coordinates
*
* written by J. Neugebauer, Uni Erlangen, 2002
*----------------------------------------------------------------------|
      implicit none
      integer natoms,nmno,lcoo,ltcoo,idbg,maxnbm
      integer ic(natoms),ipre
      real*8 normmod(3*natoms*maxnbm),co(3,natoms),dco(3,natoms)
      real*8 cstep,cstepq
      character*(*) coord
      character*255 tcoord
      parameter(idbg=6)
      cstepq=cstep*dble(ipre)
      call modcoord(co,dco,natoms,normmod(3*natoms*(nmno-1)+1),cstepq)
      return
      end

!************************************************************************

      subroutine modcoord(co,dco,natoms,dmode,cstep)
*----------------------------------------------------------------------|
* yields new coordinates dco = co + cstep*dmode
*
* written by J. Neugebauer, Uni Erlangen, 2002
*----------------------------------------------------------------------|
      implicit none
      integer natoms,i
      real*8 co(3*natoms),dco(3*natoms),dmode(3*natoms),cstep

      do i=1,3*natoms
        dco(i)=co(i)+cstep*dmode(i)
      end do
      return
      end

!************************************************************************

  subroutine create_dipol_dq_direct(dipol_dxyz,dipol,distortion)
    implicit none
    !----------------------------------------------------------------
    ! calculation off first derivative of dipolmoment with
    ! following formula:
    !
    !  d dipol    dipol(xi+e(xi) - dipol(xi-e(xi))
    ! -------- = ---------------------------------
    !    dxi                 2*e(xi)
    !
    ! unit is e since dipolmoment is e*bohr and distortion is also
    ! given in bohr.
    !
    ! written by Carsten Kind and Markus Reiher, Uni Erlangen, 1999
    ! modified by J. Neugebauer, Uni Erlangen, 2001
    ! (correction of 5-point central differences formula)
    ! extended by J. Neugebauer, Uni Erlangen, 2002
    ! (introduction of 7-point central differences formula)
    !----------------------------------------------------------------
    real(double),pointer :: dipol_dxyz(:,:)
    real(double),intent(in) :: dipol(:,:,:)
    real(double),intent(in) :: distortion(:)
    integer :: idum
    allocate(dipol_dxyz(ubound(dipol,1),ubound(dipol,2)))
    idum=ubound(dipol,3)
    if (idum.eq.2) then
       dipol_dxyz(1,:) = 0.5d0/distortion(:)*(dipol(1,:,1)-dipol(1,:,2))
       dipol_dxyz(2,:) = 0.5d0/distortion(:)*(dipol(2,:,1)-dipol(2,:,2))
       dipol_dxyz(3,:) = 0.5d0/distortion(:)*(dipol(3,:,1)-dipol(3,:,2))
    else if (idum.eq.4) then
       dipol_dxyz(1,:) = 1.0d0/(24.0d0*distortion(:))*(-2.0d0*dipol(1,:,1)&
        & +16.0d0*dipol(1,:,2)-16.0d0*dipol(1,:,3)+2.0d0*dipol(1,:,4))
       dipol_dxyz(2,:) = 1.0d0/(24.0d0*distortion(:))*(-2.0d0*dipol(2,:,1)&
        & +16.0d0*dipol(2,:,2)-16.0d0*dipol(2,:,3)+2.0d0*dipol(2,:,4))
       dipol_dxyz(3,:) = 1.0d0/(24.0d0*distortion(:))*(-2.0d0*dipol(3,:,1)&
        & +16.0d0*dipol(3,:,2)-16.0d0*dipol(3,:,3)+2.0d0*dipol(3,:,4))
    else if (idum.eq.6) then
       dipol_dxyz(1,:) = 1.0d0/(720.0d0*distortion(:))*(-12.0d0*dipol(1,:,6)&
       & +108.0d0*dipol(1,:,5)-540.0d0*dipol(1,:,4)+540.0d0*dipol(1,:,3) &
       & -108.0d0*dipol(1,:,2)+12.0d0*dipol(1,:,1))
       dipol_dxyz(2,:) = 1.0d0/(720.0d0*distortion(:))*(-12.0d0*dipol(2,:,6)&
       & +108.0d0*dipol(2,:,5)-540.0d0*dipol(2,:,4)+540.0d0*dipol(2,:,3) &
       & -108.0d0*dipol(2,:,2)+12.0d0*dipol(2,:,1))
       dipol_dxyz(3,:) = 1.0d0/(720.0d0*distortion(:))*(-12.0d0*dipol(3,:,6)&
       & +108.0d0*dipol(3,:,5)-540.0d0*dipol(3,:,4)+540.0d0*dipol(3,:,3) &
       & -108.0d0*dipol(3,:,2)+12.0d0*dipol(3,:,1))
    else
       call serror('create_dipol_dxyz',2,'Wrong ctrl%numderiv value!')
    end if
  end subroutine create_dipol_dq_direct

!************************************************************************

end module snf_progno3
