      subroutine initdir(logfile)
c     ============================================================
c     purpose: create temporary directories, set logfile names,
c              set length of directories and logfiles, and
c              print information about these names
c
c              in parallel version: get info from master
c              in serial version  : info already stored in param.h
c  
c     written by J. Neugebauer, ETHZ, 01/2007
c     (adapted from islave)
c     ============================================================
      include 'defs.h'
      include 'param.h'

      integer lf,info,xeq,now
      external xeq
      character*255 b1,b2,logfile,fname

      include 'VERSION.h'

c     -------------------------------------------------------
c     receive logdir
c     -------------------------------------------------------
C//SKIPC~1
      call pgetstr('islave: logdir',logdir,tid0,255,401,info)
      call slen(logdir,ll)
      write (iosl,*) 'islave: logdir=',logdir(1:ll)

c     -------------------------------------------------------
c     determine name of logfile for this slave
c     -------------------------------------------------------
      call clean(fname)
      call secs(now)
      call augnum(fname,logdir(1:ll)//'dclog.',now)
      call slen(fname,lf)
      call clean(logfile)
      call augnum(logfile,fname(1:lf)//'_',mytid)
      call slen(logfile,lf)

c     -------------------------------------------------------
c     open logfile in unit <iosl>
c     -------------------------------------------------------
C//SKIPC~1
      open (unit=iosl,file=logfile(1:lf),STATUS='UNKNOWN')
      write (iosl,*) '>>> snfdc slave log file for tid ',mytid
      write (iosl,*) version

c     -------------------------------------------------------
c     receive directory node names
c     -------------------------------------------------------
C//SKIPC~
      call pgetstr('islave: progdir',progdir,tid0,255,402,info)
      call pgetstr('islave: arpath',arpath,tid0,255,403,info)
      call pgetstr('islave: masterid',masterid,tid0,255,404,info)
      call pgetstr('islave: tmpnode',b1,tid0,255,405,info)
      call pgetstr('islave: mydir',mydir,tid0,255,406,info)
C//END
      write (iosl,*) 'islave: progdir=',progdir
      call flush(iosl)
      call slen(mydir,lm)
      call slen(arpath,lar)
      call slen(progdir,lb)
      call slen(masterid,li)
C//SKIPC~1
      call slen(b1,lt)
C~    call slen(tempdir,lt)
C~    b1(1:lt) = tempdir(1:lt)

C#      now=now+mytid

      call clean(b2)
      call fdate(b2)
      write (iosl,*) b2(1:40)
      call flush(iosl)

      write (iosl,*) 'TMPDIR=',b1(1:lt)
      write (iosl,*) 'LOGDIR=',logdir(1:ll)
      if (lb.gt.0) write (iosl,*) 'PROGDIR=',progdir(1:lb)
      write (iosl,*) 'MYDIR =',mydir(1:lm)

      call augnum(tempdir,b1(1:lt)//'/TMP',now)
      call slen(tempdir,lt)
      write (iosl,*) 'PE0 TID=',tid0
      call flush(iosl)
      info=xeq('mkdir '//tempdir(1:lt))
      if(info.ne.0) then
        write(iosl,'(2a)') '** initdir: cannot make directory: ',
     *    tempdir(1:lt)
        call flush(iosl)
        call errex('cannot create directory on slave node')
      end if
      
      end
