CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************

      subroutine mnotify(icase,pid,irc,cmd,len)

c     ==========================================================================
c     purpose: sent messages to the master process (received by subroutine fsys)
c 
c     adapted for serial version by J. Neugebauer, ETH Zurich, 2007
c     ==========================================================================

      include 'defs.h'
      include 'comm.h'
      include 'param.h'

      integer pid,len
      integer icase,info,mbuf,irc
      integer dest
      integer*4 tid4,pid4,irc4,icase4,ilen4

      character*255 cmd
      character*24 date

C#    integer w,st(MPI_STATUS_SIZE)
C#    data w /MPI_COMM_WORLD/

      call fdate(date)
      if (icase.lt.3) write (iosl,*) date,icase,pid,irc,' ',cmd(1:len)
      tid4=mytid
      pid4=pid
      irc4=irc
      dest=tid0
      icase4=icase
      ilen4=len

c     ---------------------
c     do not send to myself
c     ---------------------
C//SKIPC~
C//SKIPC#1
      if (tid0.eq.PVMNOPARENT) return
C#    if (mytid.eq.tid0) return

c     --------------------------------
c     do not send if pvm is not up ...
c     --------------------------------
      if (mytid.LT.0) return

C#    call MPI_SEND(mytid,1,MPI_INTEGER,tid0,fsys_mpitag,w,info)
C#    call mpierr('MPI_SEND mytid','mnotify',info)
C#    call MPI_SEND(fsys_mnotify,1,MPI_INTEGER,tid0,501,w,info)
C#    call mpierr('MPI_SEND mnotify','mnotify',info)
C#    call MPI_SEND(pid,1,MPI_INTEGER,tid0,502,w,info)
C#    call mpierr('MPI_SEND pid','mnotify',info)
C#    call MPI_SEND(irc,1,MPI_INTEGER,tid0,503,w,info)
C#    call mpierr('MPI_SEND irc','mnotify',info)
C#    call MPI_SEND(icase,1,MPI_INTEGER,tid0,504,w,info)
C#    call mpierr('MPI_SEND icase','mnotify',info)
C#    call MPI_SEND(len,1,MPI_INTEGER,tid0,505,w,info)
C#    call mpierr('MPI_SEND len','mnotify',info)
C#    call MPI_SEND(cmd,len,MPI_CHARACTER,tid0,506,w,info)
C#    call mpierr('MPI_SEND cmd','mnotify',info)
C//SKIPC#
      call PVMFINITSEND(PVMDATADEFAULT,mbuf)
      call PVMFPACK(INTEGER4,tid4,1,1,info)
      call PVMFPACK(INTEGER4,pid4,1,1,info)
      call PVMFPACK(INTEGER4,irc4,1,1,info)
      call PVMFPACK(INTEGER4,icase4,1,1,info)
      call PVMFPACK(INTEGER4,ilen4,1,1,info)
      call PVMFPACK(STRING,cmd,len,1,info)
      call PVMFSEND(dest,BAHFSYSCAL,info)
      if (info.ne.0) call pvmfperror('mnotify',info)
      call ssys
C//END
C//END
      return
      end
