CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine molprslave(grad,co,ilab,nmode,freq,intonly,nummodes)

c     ====================================================================
c     purpose: perform a MOLPRO single point calculation for a displaced
c              structure, collect the results, and send them to master
c 
c     history:
c       - written by S. Luber, ETH Zuerich, June 2006
c       - cleaned and modified by J. Neugebauer, ETH Zurich, 01/2007
c     ====================================================================

      include 'defs.h'
      include 'param.h'  

      integer info,l
      integer j,lmolp
      character*255 molpname
      real*8 escf
      real*8 nmode(maxmode,maxatoms*3),freq(maxmode)

      integer xprogb,xprog
      integer*4 itst,jstepa
      character*5 nic
      real*8 cpu,wall,gcpu,gwall
      integer*4 nit
      integer xeq,tmpxeq,icmp
      real*8 grad(nvar),dipol(3),co(3,natoms),polar(8,mxomeg)
      real*8 gtenlao(9,mxomeg),gtenao(9,mxomeg),aten(27,mxomeg)
      integer ilab(natoms)
      integer intonly,nummodes

      logical found

*-------------------
* call rslave module
*-------------------
      call rslave(co,ilab,jstepa,nmode,freq,intonly,nummodes,nic)

*--------------------------
* prepare in-/output file names
*--------------------------
      call augnum(molpname,'molpro.out.',jstepa)
      call llen(molpname,lmolp)

*-----------
* run MOLPRO
*-----------
           info=xprog(nic(1:5)//progdir(1:lb)//'molpro<'//tempdir(1:lt)//
     *     '/molpslave.in',tempdir(1:lt)//'/'//molpname(1:lmolp))
*-------------------------------------
* read gradient 
*-------------------------------------
      CALL gmolpgrad(natoms,escf,dipol,grad,tempdir(1:lt)//'/'
     *                //molpname(1:lmolp))
      nit=0
      cpu=0.d0
      gcpu=0.d0
      wall=0.d0
      gwall=0.d0

c     ------------------
c     send final results
c     ------------------
      call sendres(nit,cpu,wall,gcpu,gwall,escf,dipol,grad,
     *   polar,gtenlao,gtenao,aten,jstepa,nummodes,intonly)

      return
      end                        
