CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************

      subroutine regrad(fname,nat,e,g)
      implicit real*8 (a-h,o-z)
      character*255 dum
      character*(*) fname
      dimension xx(10),g(*)

      open(unit=42,file=fname,STATUS='UNKNOWN')

 10   read(42,'(a)',end=100) dum
      if(index(dum,'cycle').ne.0) then
         call readl(255,dum,xx,n)
         e=xx(n-1)
         do i=1,nat
            read(42,'(a)',end=100) dum
         enddo
         k=1
         do i=1,nat
            read(42,'(a)',end=100) dum
            call readl(255,dum,xx,n)
            g(k)  =xx(1)
            g(k+1)=xx(2)
            g(k+2)=xx(3)
            k=k+3
         enddo
      endif
      goto 10
 100  close(42)

      return
      end
C--------------------------------------------

      subroutine readtm(ffile,nl,maxl,buf)
      implicit real*8 (a-h,o-z)
      character*(*) ffile
      integer nl
      dimension buf(*)
      character*(*) buf
      character*100 dum

      open(unit=42,file=ffile,STATUS='UNKNOWN')

      nl=0
 10   read(42,'(a)',end=100) dum
      nl=nl+1
      if(nl.gt.maxl) then
         write(*,*) 'buffer too small. file: ',ffile
         stop
      endif
      buf(nl)=dum
      goto 10
 100  close(42)

      return
      end
C--------------------------------------------

      subroutine findstr(ffile,str,found)
      implicit real*8 (a-h,o-z)
      character*(*) ffile,str
      character*100 dum
      logical found

      found=.false.

      open(unit=42,file=ffile,STATUS='UNKNOWN')

      nl=0
 10   read(42,'(a)',end=100) dum
      if(index(dum,str).ne.0) then
         found=.true.
         close(42)
         return
      endif      
      goto 10
 100  close(42)

      return
      end

C--------------------------------------------

      subroutine writetm(ffile,nl,buf)
      implicit real*8 (a-h,o-z)
      character*(*) ffile
      dimension buf(*)
      character*(*) buf
      integer nl

      open(unit=42,file=ffile,STATUS='UNKNOWN')

      do i=1,nl
         write(42,'(a)') buf(i)
      enddo

      close(42)
      return
      end

C--------------------------------------------

      subroutine rtm_it_time(fn,nit,cpu,wall)

c     =============================================================
c     read number of SCF cycles, CPU and wall clock time from
c     Turbomole output file <fn>
c
c     former name: rxxxx
c     renamed and cleaned by J. Neugebauer, ETHZ, 01/2007
c     =============================================================

      implicit none
      include 'param.h'

      integer info,l,irc,xeq,nit
      integer lu,i,intgr
      real*8 cpu,wall,rr
      character*(*) fn
      character*255 b1,b2,filename,item(mxitem)
      logical yes

      call clean(filename)
      filename=tempdir(1:lt)//'/'//fn
      nit=0
      cpu=0.
      wall=0.

      inquire (file=filename,exist=yes)
      if (yes) then
        lu=1
        open (unit=lu,file=filename,status='OLD')
1       read (lu,'(A)',end=999) filename
        call split(filename,item,mxitem)
        i=0
        if (item(3).eq.'satisfied') nit=intgr(item(5),i,20)
        if (item(2).eq.'cpu-time') call tosec(item,cpu)
        if (item(2).eq.'wall-time') call tosec(item,wall)
        goto 1
999     close (unit=lu)
      endif

      return
      end
