CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE readv(what,val,default)
      IMPLICIT none
      INCLUDE 'param.h'
*
      CHARACTER*(*) what,val,default
      INTEGER l,j,nrec,l1,l2
      CHARACTER*255 rec,item(mxitem)
      CALL clean(val)
      DO nrec=1,inrec
       CALL split(infi(nrec),item,mxitem)
       IF (item(1).EQ.what) THEN
        l1=LEN(val)
        IF (item(2)(1:1).EQ.'''') THEN
         CALL llen(infi(nrec),l2)
         j=MIN0(l1,l2)
        val(1:j)=infi(nrec)(1:j)
        ELSE
         CALL llen(item(2),l2)
         j=MIN0(l1,l2)
         val(1:j)=item(2)(1:j)
        ENDIF
       ENDIF
      ENDDO
      IF (val(1:1).EQ.' ') THEN
       IF (default(1:1).EQ.'#') THEN
        WRITE (*,*) what,' not found in input'
        CALL errex('input error')
       ELSE
        val(1:LEN(default))=default
       ENDIF
      ENDIF
      RETURN
      END

      subroutine rkeystr(anfname,anfkey,anfstr)
C
C read file anfname; if <anfkey> is present, then read string
C variable anfstr from the keyword input line
C
C written by J. Neugebauer, Uni Erlangen, 2002.
C
      implicit none
      integer lu,lanfn,lanfk,lstr
      character*(*) anfname,anfstr,anfkey
      character*255 buf,anfold
      logical ex
      lu=1
      call slen(anfstr,lstr)
      call clean(anfold)
      anfold(1:lstr)=anfstr(1:lstr)
      call clean(anfstr)
      call slen(anfname,lanfn)
      call slen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) then
        anfstr(1:lstr)=anfold(1:lstr)
        return
      end if
      open(unit=lu,file=anfname(1:lanfn))
10    read(lu,'(A)',end=900) buf
      if(index(buf,anfkey(1:lanfk)).ne.0) then
        read(buf(lanfk+2:),'(A)',err=800,end=800) anfstr
        goto 900
      end if
800   anfstr(1:lstr)=anfold(1:lstr)
      goto 10
900   close(lu)
      end
