CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine wrestart(vmach,dip,pol,gtenlao,gtenao,aten,gra,istepfl,
     *                    intonly,nummodes)
CSL   modified by S. Luber, ETH Zurich, 2006
CMR   modified by M. Reiher for VROA, Uni Erlangen, June 2003
CCH   modified by C. Herrmann, Uni Bonn, 02/2005
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      CHARACTER*255 form
      INTEGER istepfl(*)
      REAL*8 dip(*)
      REAL*8 pol(mxomeg,*)
      REAL*8 gra(*)
      REAL*8 vmach(*)
      INTEGER i,j,k,in1,ires,imin,jomeg
      CHARACTER*24 date

      REAL*8 gtenlao(mxomeg,*),gtenao(mxomeg,*),aten(mxomeg,*)
      LOGICAL vroaflag
      INTEGER ipoldum
      integer intonly,nummodes,l,numi,numj
      character*4 stepchar

      include 'VERSION.h'
      data form /'(4D20.10)'/

      in1=88
      vroaflag=.false.

      ipoldum=ipol
      IF (ipol-1000.ge.0) THEN
        vroaflag=.true.
        ipoldum=ipol-1000
        IF (ipoldum.eq.0) ipoldum=1
      ENDIF

      open (unit=in1,file=restart,status='UNKNOWN')
      write (in1,'(A)') title
      write (in1,'(A)') form

c     -------------------------------------------------
c     ipol           number of sets of polarizabilities
c                    (for different frequencies)
c     if(ipol.eq.0) => no Raman calculation
c     -------------------------------------------------

      write (in1,'(14I5)') ivers,progno,calcno,ipol,nvar,naus,nummodes
      write (in1,form) cstep
      write (in1,'(A)') mydir(1:lm)
      write (in1,'(A)') tempdir(1:lm)

c     --------------------------------------------------------------------
c     in order to avoid nearly redundant code in intonly version, 
c     numi, numj and stepchar are introduced - numj in standard version is 
c     3* numj in intonly version since 3 elongations per atom and ...
c     are needed instead of only one per normal mode
c     --------------------------------------------------------------------

      if(intonly.eq.1) then
        numi=nummodes
        numj=naus
        stepchar='mode'
      else
        numi=natoms
        numj=naus*3
        stepchar='atom'
      end if 
      DO i=1,numi
       j=(i-1)*numj
       WRITE (in1,'(24I3)') i,(istepfl(k),k=j+1,j+numj)
       WRITE (in1,'(12A8)') (vmach(k),k=j+1,j+numj)
      ENDDO
      DO i=1,numi
       WRITE (in1,*) 'dipoles '//stepchar,i
       j=(i-1)*numj*3
       WRITE (in1,form) (dip(k),k=j+1,j+numj*3)
      ENDDO
      if(intonly.eq.0) then
        DO i=1,natoms
         WRITE (in1,*) 'gradients atom',i
         j=(i-1)*3*naus*nvar
         WRITE (in1,form) (gra(k),k=j+1,j+naus*nvar*3)
        ENDDO
      end if
*
* polarizabilities
*
      if (.not.vroaflag) then
       DO jomeg=1,ipol
        DO i=1,numi
         j=(i-1)*numj*8
         WRITE (in1,'(a22,i8,a13,d20.10)') ' polarizabilities '//
     *         stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (pol(jomeg,k),k=j+1,j+numj*8)
        ENDDO
       ENDDO
      else
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*8
         WRITE (in1,'(a22,i8,a13,d20.10)') ' polarizabilities '
     *         //stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (pol(jomeg,k),k=j+1,j+numj*8)
        ENDDO
       ENDDO
c
C in case of VROA with Turbomole (progno=1):
c multiply the rotatory dispersion values
C (read in as gtenlao (in the length representation) and gtenao
c (in the velocity representation)) with the laser frequency
c to get the G tensor values;
c the A tensor values are zero;
C 
       if(progno.ne.1) then
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*9
         WRITE (in1,'(a22,i8,a13,d20.10)') ' G tensors (LAO) '//
     *         stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (gtenlao(jomeg,k),k=j+1,j+numj*9)
        ENDDO
       ENDDO
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*9
         WRITE (in1,'(a22,i8,a13,d20.10)') ' G tensors (AO) '//
     *          stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (gtenao(jomeg,k),k=j+1,j+numj*9)
        ENDDO
       ENDDO
       else
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*9
         WRITE(in1,'(a26,i8,a13,d20.10)')' G tensors (length) '//
     *         stepchar,i,' frequency = ',omeg(jomeg)
         WRITE(in1,form)((gtenlao(jomeg,k)*omeg(jomeg)),k=j+1,j+numj*9)
        ENDDO
       ENDDO
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*9
         WRITE(in1,'(a26,i8,a13,d20.10)')' G tensors (veloc.) '//
     *          stepchar,i,' frequency = ',omeg(jomeg)
         WRITE(in1,form) ((gtenao(jomeg,k)*omeg(jomeg)),k=j+1,j+numj*9)
        ENDDO
       ENDDO
       end if
c
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*27
         WRITE (in1,'(a22,i8,a13,d20.10)') ' A tensors '//
     *          stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (aten(jomeg,k),k=j+1,j+numj*27)
        ENDDO
       ENDDO
      endif

      CALL fdate(date)
      WRITE (in1,'(A)') date
**    WRITE (in1,'(A8,I8)') (vmach(k),is(pti+k-1),k=1,nnode)
      CLOSE (in1)
      RETURN
      END

c***************************************************************************++

      subroutine rrestart(vmach,dip,pol,gtenlao,gtenao,aten,
     *                    gra,istepfl,isum,intonly,nummodes)
CMR   modified by M. Reiher for VROA, Uni Erlangen, June 2003
CCH   modified by C. Herrmann for intensities only mode, 02/2005

      include 'defs.h'
      include 'param.h'

      integer istepfl(*)
      character*255 form,buf
      integer i,j,k,isum,jvers,iaus,in1
      integer jomeg,komeg,mprogno,mcalcno,mpol
      logical ex
      real*8 pstep
      real*8 dip(*),vmach(*)
      real*8 pol(mxomeg,*)
      real*8 gra(*)

      real*8 gtenlao(mxomeg,*),gtenao(mxomeg,*),aten(mxomeg,*)
      logical vroaflag
      integer ipoldum
      integer intonly,nummodes,l,numi, numj
      character*4 stepchar

      include 'VERSION.h'

      vroaflag=.false.
      intonly=0

      in1=88
      inquire (file=restart,exist=ex)
      if (.not.ex) return

      open (unit=in1,file=restart,status='old')
      rewind(in1)
      read(in1,'(a)')
      read(in1,'(a)') form
      read(in1,'(14i5)') jvers,mprogno,mcalcno,mpol,nvar,iaus,nummodes
      if(nummodes.ne.0) intonly = 1

c     ===========================================================
c     in order to avoid nearly redundant code in intonly version,
c     numi, numj and stepchar are introduced (CH)
c     ===========================================================
      if(intonly.eq.1) then
        numi=nummodes
        numj=naus
        stepchar='mode'
      else
        numi=natoms
        numj=naus*3
        stepchar='atom'
      end if

      ipoldum=mpol
      if (mpol-1000.ge.0) then
        vroaflag=.true.
        ipoldum=mpol-1000
        if (ipoldum.eq.0) ipoldum=1
      endif

      i=ivers/10
      j=jvers/10
      if (jvers.lt.170) then
        write (*,*) '****** incompatible versions '
        write (*,*) '****** version on restart file :',jvers
        write (*,*) '****** current program version :',ivers
        call errex('incompatible restart file')
      endif
      if (calcno.ne.mcalcno) then
        write (*,*) '****** <control> file has been changed:'
        write (*,*) '****** calculation type on restart file :',mcalcno
        write (*,*) '****** current program mode :',calcno
        call errex('incompatible restart file')
      endif
      if (progno.ne.mprogno) then
        write (*,*) '****** <control> file has been changed:'
        write (*,*) '****** program no. on restart file :',mprogno
        write (*,*) '****** current program mode :',progno
        call errex('incompatible restart file')
      endif
      if (ipol.ne.mpol) then
        write (*,*) '****** <control> file has been changed:'
        write (*,*) '****** ipol on restart file :',mpol
        write (*,*) '****** current program ipol from snf_control:',ipol
        call errex('incompatible restart file')
      endif
      if (naus.ne.iaus) then
        write (*,*) '****** <control> file has been changed:'
        write (*,*) '****** restart file is using ',iaus,' point formula'
        write (*,*) '****** current program is using ',naus,
     *  ' point formula'
        call errex('incompatible restart file')
      endif
      read (in1,form) pstep
      if (dabs(cstep-pstep).gt.1.d-6) then
        write (*,*) '****** cstep has been changed:'
        write (*,*) '****** cstep on restart file     :',pstep
        write (*,*) '****** current program cstepmode :',cstep
        call errex('incompatible restart file')
      endif
      read (in1,'(a)') 
      read (in1,'(a)') 
      do i=1,numi
        j=(i-1)*numj
        read (in1,'(24i3)') k,(istepfl(k),k=j+1,j+numj)
        read (in1,'(12a8)') (vmach(k),k=j+1,j+numj)
      enddo
      do i=1,numi
        read (in1,'(a)')
        j=(i-1)*numj*3
        read (in1,form) (dip(k),k=j+1,j+numj*3)
      enddo
      if(intonly.eq.0) then
        do i=1,natoms
          read (in1,'(a)')
          j=(i-1)*3*naus*nvar
          read (in1,form) (gra(k),k=j+1,j+naus*nvar*3)
        enddo
      end if
*
* polarizabilities
*
      if (.not.vroaflag) then
        do jomeg=1,ipol
          do i=1,numi
            j=(i-1)*numj*8
            read (in1,'(a)')
            read (in1,form) (pol(jomeg,k),k=j+1,j+numj*8)
          enddo
        enddo
      else
        do jomeg=1,ipoldum
          do i=1,numi
            j=(i-1)*numj*8
            read (in1,'(a)')
            read (in1,form) (pol(jomeg,k),k=j+1,j+numj*8)
          enddo
        enddo
        do jomeg=1,ipoldum
          do i=1,numi
            j=(i-1)*numj*9
            read (in1,'(a)')
            read (in1,form) (gtenlao(jomeg,k),k=j+1,j+numj*9)
          enddo
        enddo
        do jomeg=1,ipoldum
          do i=1,numi
            j=(i-1)*numj*9
            read (in1,'(a)')
            read (in1,form) (gtenao(jomeg,k),k=j+1,j+numj*9)
          enddo
        enddo
        do jomeg=1,ipoldum
          do i=1,numi
            j=(i-1)*numj*27
            read (in1,'(a)')
            read (in1,form) (aten(jomeg,k),k=j+1,j+numj*27)
          enddo
        enddo
      endif
 
      isum=0
      do i=1,nstept
        if(istepfl(i).eq.-1) istepfl(i)=0 
        isum=isum+istepfl(i) 
      enddo

      write(*,*)'% done yet',100.0d0*dble(isum)/dble(nstept)

      close (in1)
      return
      end
