      subroutine rmolpcoord(name,natoms,co,ilab,iosl)
*-------------------------------------------------------------------
c  read in coordinates from Molpro input file name
c
c  written by S. Luber, ETH Zuerich, June 2006 
*-------------------------------------------------------------------
      implicit none
c
      integer gunit,natoms,i,j,firstcomma,seccomma,thirdcomma,z
      integer diffone,diffsec,diffthird,diffseco,diffthir
      integer ist,end,ilab(*),find_nucl_charge,lname,iosl
      character*(132) row,zeile
      character*(2) el(natoms)
      real*8 co(3,natoms)
      character*(*) name
      logical ex

      include 'fconstants.h' 
      gunit = 12
c
      call slen(name,lname)
      write(iosl,'(a)') '** rmolpcoord: looking for molpro input file:'
      write(iosl,'(3a)') '|',name(1:lname),'|'
      inquire(file=name(1:lname),exist=ex)
      if(.not.ex) then
        write(iosl,'(a)') '** rmolpcoord: molpro input file not found!'
        call errex('** rmolpcoord: molpro input file not found')
      end if

      open(gunit,file=name(1:lname),status='unknown')
1     read(gunit,'(a132)',end=40) row
      if(index(row,'geometry').ne.0) then
        read(gunit,'(a132)',end=40) row
        if(row(1:10).ne.'           ') then
          read(row,*) natoms
          read(gunit,'(a132)',end=40) row
          i=1
2         read(gunit,'(a132)',end=40) zeile
          if(zeile(1:10).ne.'        ' .and. zeile(1:10).ne.'}') then
            firstcomma=index(zeile,',')
            diffone=firstcomma+1
            seccomma=index(zeile(diffone:132),',')+firstcomma
            diffseco=seccomma+1
            thirdcomma=index(zeile(diffseco:132),',')+seccomma
            diffsec=seccomma-1
            diffthir=thirdcomma-1
            diffthird=thirdcomma+1
            read(zeile(diffone:diffsec),*) co(1,i)
            read(zeile(diffseco:diffthir),*) co(2,i)
            read(zeile(diffthird:132),*) co(3,i)
            do j=1,3
              co(j,i) =  co(j,i)*(1/bohr2ang)
            end do
            j=firstcomma-1
5           if (zeile(j:j).eq.'0') then
               j=j-1 
               goto 5
            else if (zeile(j:j).eq.'1') then 
              j=j-1
              goto 5
            else if (zeile(j:j).eq.'2') then 
              j=j-1 
              goto 5
            else if (zeile(j:j).eq.'3') then 
              j=j-1 
              goto 5
            else if (zeile(j:j).eq.'4') then 
              j=j-1 
              goto 5
            else if (zeile(j:j).eq.'5') then 
              j=j-1 
              goto 5
            else if (zeile(j:j).eq.'6') then 
              j=j-1 
              goto 5
            else if (zeile(j:j).eq.'7') then
              j=j-1 
              goto 5
            else if (zeile(j:j).eq.'8') then
              j=j-1 
              goto 5
            else if (zeile(j:j).eq.'9') then
              j=j-1 
              goto 5
            else 
              el(i)=zeile(1:j)
            end if 
            ilab(i)=find_nucl_charge(el(i))
            i=i+1
            goto 2
          end if
        end if
      end if
      goto 1
40    continue
      close(gunit)
  
      end 

c*******************************************************
      subroutine wmolp(tdr,natoms,ic,co)
*
*-------------------------------------------------------------------
*
*  generates Molpro-input file 'molpslave.in' on slaves
*
*  link 0 commands, route section, title section,
*  and molecule specification are read from 'molpro.in'
*  as provided by the user.
*
*  written by S. Luber, ETH Zuerich, June 2006
*
*-------------------------------------------------------------------
*
      implicit none
c
      integer gunit,aunit,natoms,mxrow
      parameter(gunit=13,aunit=14,mxrow=10000)
c ltd: length of temporary directory        
      integer ic(natoms),ltd,i,igeom,iend,j            
      real*8 co(3,natoms)
c tdr: temporary directory      
      character*(*) tdr
      character*80 row(mxrow),zeile(3)
      integer lrow(mxrow),lz(3)
      character*2 find_element
      external find_element
      character*255 fname, aname, element(natoms)
      include 'fconstants.h'
      call llen(tdr,ltd)
      aname=tdr(1:ltd)//'/molpro.in'
      fname=tdr(1:ltd)//'/molpslave.in'
c
      open(aunit,file=aname,status='unknown')
      i=1 
1     read(aunit,'(a)',end=30) row(i)
        call llen(row(i),lrow(i))
        write(50,*) 'i =', i, row(i)
        if(index(row(i),'geometry').ne.0) then
        igeom=i
	write(50,*) 'igeom = ', igeom
        zeile(1)=row(i)
        read(aunit,'(a)') zeile(2)
        read(aunit,'(a)') zeile(3)
	do j=1,3
	  call llen(zeile(j),lz(j))
	end do
        end if
      i=i+1
      goto 1
30    iend=i-1
	write(50,*) 'iend = ', iend
      continue
      close(aunit)       
c
      open(unit=gunit,file=fname,status='unknown')
      write(gunit,'(a)') (row(i)(1:lrow(i)),i=1,igeom-1)
      write(gunit,'(a)') (zeile(i)(1:lz(i)),i=1,3)
      do i=1,natoms
        write(gunit,10) find_element(ic(i)),co(1,i)*bohr2ang,
     *  co(2,i)*bohr2ang,co(3,i)*bohr2ang
      end do
      write(gunit,'(a)') (row(i)(1:lrow(i)),i=igeom+1+natoms,iend)
10    format(a,',',2(F18.12,','),F18.12)
      write(gunit,*) 
      close(gunit)
c
      end 
c*******************************************************
      subroutine rmolp(name,natoms)
*-------------------------------------------------------------------
*  read in number of atoms from molpro input file name
c
c  written by S. Luber, ETH Zuerich, June 2006
c  modified by C. Herrmann, ETH Zurich, January 2007
*-------------------------------------------------------------------
      implicit none
c
      integer gunit,natoms,i,j
      integer ist,end,srow,lrow
c     parameter(mxitem=10)
      character*(132) row
      character*(*) name
c
      gunit = 11
c
      open(gunit,file=name,err=3,status='unknown')
1     read(gunit,'(a132)',end=2) row
      if(index(row,'geometry').ne.0) then
        read(gunit,'(a132)',end=2) row 
c       call slen(row,srow)
c       call llen(row,lrow)
c       row=row(srow:lrow)
        if(row(1:10).ne.'           ') then
          read(row,*) natoms
        end if
      end if
      goto 1 
2     continue
      close(gunit) 
      return
3     write(*,*)
      write(*,'(2x,2a)') 
     & 'ERROR: rmolp: Could not open molpro input file ',name
      write(*,*)

      end 
