      subroutine sendres(nit,cpu,wall,gcpu,gwall,escf,dipol,grad,
     *   polar,gtenlao,gtenao,aten,jstepa,nummodes,intonly)

c     ==============================================================
c     send final results using SCP, PVM, MPI, or pass them to serres
c     
c     written by J. Neugebauer, ETHZ, 2007,
c     using former rslave routines as templates
c     ==============================================================

      include 'defs.h'
      include 'comm.h'
      include 'param.h'

      integer ipoldum,info,j,kstep,mbuf,jstepa,nummodes,intonly
      integer*4 nit
      real*8 escf,cpu,wall,gcpu,gwall,gsum
      real*8 dipol(3),grad(nvar),polar(8,mxomeg)
      real*8 gtenlao(9,mxomeg),gtenao(9,mxomeg),aten(27,mxomeg)
      logical vroaflag

C#    integer w,st(MPI_STATUS_SIZE)
C#    data w /MPI_COMM_WORLD/

      kstep = 1
c     --------------------------------------------------------
c     determine vroaflag and ipoldum
c     --------------------------------------------------------
      vroaflag=.false.
      ipoldum=ipol
      if ((ipol-1000).ge.0) then
        vroaflag=.true.
        ipoldum=ipol-1000
        if (ipoldum.eq.0) ipoldum=1
      end if

c     --------------------------------------------------------
c     determine gsum and write it
c     --------------------------------------------------------
      gsum=0.0d0
      do j=1,nvar
         gsum=gsum+grad(j)**2
      enddo
      write (iosl,*) 'grad norm',gsum
      call flush(iosl)

c     --------------------------------------------------------
c     write no. of SCF iterations, CPU and wall clock time
c     --------------------------------------------------------
      write (iosl,*) 'scf energy: ',escf
      write (iosl,*) 'dipole    : ',dipol(1),dipol(2),dipol(3)
      write (iosl,*) 'grad(1)   : ',grad(1)
      write (iosl,*) 'iterations: ',nit
      write (iosl,*) 'cpu       : ',cpu
      write (iosl,*) 'wall      : ',wall
      write (iosl,*) 'gwall     : ',gwall
      call flush(iosl)

c     --------------------------------------------------------
c     MPI block using MPI_SSEND
c     --------------------------------------------------------

C:      call MPI_SSEND(nit,1,MPI_INTEGER,tid0,fsys_restag,w,info)
C:      call mpierr('MPI_SSEND nit','rslave',info)
C:      call MPI_SSEND(cpu,1,MPI_DOUBLE_PRECISION,tid0,801,w,info)
C:      call mpierr('MPI_SSEND cpu','rslave',info)
C:      call MPI_SSEND(wall,1,MPI_DOUBLE_PRECISION,tid0,802,w,info)
C:      call mpierr('MPI_SSEND wall','rslave',info)
C:      call MPI_SSEND(gcpu,1,MPI_DOUBLE_PRECISION,tid0,803,w,info)
C:      call mpierr('MPI_SSEND gcpu','rslave',info)
C:      call MPI_SSEND(gwall,1,MPI_DOUBLE_PRECISION,tid0,804,w,info)
C:      call mpierr('MPI_SSEND gwall','rslave',info)
C:      call MPI_SSEND(escf,1,MPI_DOUBLE_PRECISION,tid0,805,w,info)
C:      call mpierr('MPI_SSEND escf','rslave',info)
C:      call MPI_SSEND(dipol,3,MPI_DOUBLE_PRECISION,tid0,806,w,info)
C:      call mpierr('MPI_SSEND dipol','rslave',info)
C:      call MPI_SSEND(grad,nvar,MPI_DOUBLE_PRECISION,tid0,807,w,info)
C:      call mpierr('MPI_SSEND grad','rslave',info)
C:      if (ipol.GT.0.and..not.vroaflag) then
C:        call MPI_SSEND(polar,8*ipol,MPI_DOUBLE_PRECISION,
C:   *     tid0,808,w,info)
C:        call mpierr('MPI_SSEND polar','rslave',info)
C:      end if
C:      if (vroaflag) THEN
C:        call MPI_SSEND(polar,8*ipoldum,MPI_DOUBLE_PRECISION,
C:   *     tid0,808,w,info)
C:        call mpierr('MPI_SSEND polar','rslave',info)
C:        call MPI_SSEND(gtenlao,9*ipoldum,MPI_DOUBLE_PRECISION,
C:   *     tid0,808,w,info)
C:        call mpierr('MPI_SSEND gtenlao','rslave',info)
C:        call MPI_SSEND(gtenao,9*ipoldum,MPI_DOUBLE_PRECISION,
C:   *     tid0,808,w,info)
C:        call mpierr('MPI_SSEND gtenao','rslave',info)
C:        call MPI_SSEND(aten,27*ipoldum,MPI_DOUBLE_PRECISION,
C:   *     tid0,808,w,info)
C:        call mpierr('MPI_SSEND aten','rslave',info)
C:      end if

c     --------------------------------------------------------
c     MPI block using MPI_SEND
c     --------------------------------------------------------

C//SKIPC:
C#    call MPI_SEND(nit,1,MPI_INTEGER,tid0,fsys_restag,w,info)
C#    call mpierr('MPI_SEND nit','rslave',info)
C#    call MPI_SEND(cpu,1,MPI_DOUBLE_PRECISION,tid0,801,w,info)
C#    call mpierr('MPI_SEND cpu','rslave',info)
C#    call MPI_SEND(wall,1,MPI_DOUBLE_PRECISION,tid0,802,w,info)
C#    call mpierr('MPI_SEND wall','rslave',info)
C#    call MPI_SEND(gcpu,1,MPI_DOUBLE_PRECISION,tid0,803,w,info)
C#    call mpierr('MPI_SEND gcpu','rslave',info)
C#    call MPI_SEND(gwall,1,MPI_DOUBLE_PRECISION,tid0,804,w,info)
C#    call mpierr('MPI_SEND gwall','rslave',info)
C#    call MPI_SEND(escf,1,MPI_DOUBLE_PRECISION,tid0,805,w,info)
C#    call mpierr('MPI_SEND escf','rslave',info)
C#    call MPI_SEND(dipol,3,MPI_DOUBLE_PRECISION,tid0,806,w,info)
C#    call mpierr('MPI_SEND dipol','rslave',info)
C#    call MPI_SEND(grad,nvar,MPI_DOUBLE_PRECISION,tid0,807,w,info)
C#    call mpierr('MPI_SEND grad','rslave',info)
C#    if (ipol.GT.0.and..not.vroaflag) then
C#      call MPI_SEND(polar,8*ipol,MPI_DOUBLE_PRECISION,
C#   *   tid0,808,w,info)
C#      call mpierr('MPI_SEND polar','rslave',info)
C#    end if
C#    if (vroaflag) then
C#      call MPI_SEND(polar,8*ipoldum,MPI_DOUBLE_PRECISION,
C#   *   tid0,808,w,info)
C#      call mpierr('MPI_SEND polar','rslave',info)
C#      call MPI_SEND(gtenlao,9*ipoldum,MPI_DOUBLE_PRECISION,
C#   *   tid0,808,w,info)
C#      call mpierr('MPI_SEND gtenlao','rslave',info)
C#      call MPI_SEND(gtenao,9*ipoldum,MPI_DOUBLE_PRECISION,
C#   *   tid0,808,w,info)
C#      call mpierr('MPI_SEND gtenao','rslave',info)
C#      call MPI_SEND(aten,27*ipoldum,MPI_DOUBLE_PRECISION,
C#   *   tid0,808,w,info)
C#      call mpierr('MPI_SEND aten','rslave',info)
C#    end if
C//END

c     --------------------------------------------------------
c     PVM block
c     --------------------------------------------------------

C//SKIPC~
C//SKIPC#
      call PVMFINITSEND(PVMDATADEFAULT,mbuf)
      call PVMFPACK(INTEGER4,nit,kstep,1,info)
      call PVMFPACK(REAL8,cpu,kstep,1,info)
      call PVMFPACK(REAL8,wall,kstep,1,info)
      call PVMFPACK(REAL8,gcpu,kstep,1,info)
      call PVMFPACK(REAL8,gwall,kstep,1,info)
      call PVMFPACK(REAL8,escf,1,1,info)
      call PVMFPACK(REAL8,dipol,3,1,info)
      call PVMFPACK(REAL8,grad,nvar,1,info)
      if (ipol.gt.0.and..not.vroaflag)
     *  call PVMFPACK(REAL8,polar,8*ipol,1,INFO)
      if (vroaflag) then
        call PVMFPACK(REAL8,polar,8*ipoldum,1,INFO )
        call PVMFPACK(REAL8,gtenlao,9*ipoldum,1,INFO )
        call PVMFPACK(REAL8,gtenao,9*ipoldum,1,INFO )
        call PVMFPACK(REAL8,aten,27*ipoldum,1,INFO )
      end if
      call PVMFSEND( TID0, 0, INFO )
C//END
C//END

c     --------------------------------------------------------
c     SERIAL block
c     --------------------------------------------------------

C~    call serres(nit,cpu,wall,gcpu,gwall,escf,dipol,grad,polar,
C~   &  gtenlao,gtenao,aten,jstepa,s8(pdip),s8(pgra),s8(ppol),
C~   &  s8(pgtenlao),s8(pgtenao),s8(paten),is(pstepfl),s8(pvmach),
C~   &  nummodes,intonly)

c     --------------------------------------------------------
c     notify master process
c     --------------------------------------------------------
      call mnotify(5,mytid,9,'results sent',12)

      return
      end
