CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine shutdown

c     =========================================================
c     shutdown the parallel machinery
c
c     modified by J. Neugebauer, Uni Erlangen, 2001
c     =========================================================

      include 'defs.h'
      include 'comm.h'
      include 'param.h'  
      include 'sadmch.h'

      integer i,k,xeq,p,tid,tpid,iwhat,info,l,mbuf
      character*255 cmd
      character*20 cpid
      character*40 myname

C#    integer w
C#    data w /MPI_COMM_WORLD/
C@    write (*,*) '@shutdown@ enter'

c     --------------------------
c     read last pending messages
c     --------------------------
      call fsys

c     ------------------------------------
c     send all slaves the terminate signal
c     ------------------------------------
      iwhat=-1
      p=pmch

90    if (p.eq.0) goto 950
      if (is(p+sadmch_nodf).eq.sadmch_dead) goto 951
      if (is(p+sadmch_nodf).eq.sadmch_done) goto 951
      call sadmch_gname(p,myname)
      call sadmch_fname(pvmmch,myname)
      k=is(p+sadmch_tid)
      l=0
      if (cmch.gt.0) l=is(cmch+sadmch_usag)
      if(k.gt.0) then
        write (idbg,*) 'shutdow| sending finish signal to tid ',k

C:      call MPI_SSEND(iwhat,1,MPI_INTEGER,k,409,w,info)
C:      call mpierr('MPI_SSEND iwhat','parstuff',info)
C//SKIPC:2
C#      call MPI_SEND(iwhat,1,MPI_INTEGER,k,409,w,info)
C#      call mpierr('MPI_SEND iwhat','parstuff',info)
C//SKIPC#
        call pvmfinitsend(PVMDATADEFAULT,mbuf)
        call pvmfpack( INTEGER4, iwhat, 1, 1, info )
        call pvmfsend(k, 0, info )
C//END
      end if

      if (l.gt.0) then
        write (jtape,'(''% work done on node '',a20,F10.2)')
     &    myname,100.*float(l)/float(nstept)
      end if

951   p=is(p+sadmch_next)
      goto 90

950   continue

C//SKIPC#
      p=pmch
1     if (p.eq.0) goto 900
      if (is(p+sadmch_tpid).gt.0) then
        tid=is(p+sadmch_tid)
        tpid=is(p+sadmch_tpid)
        call sadmch_gname(p,myname)
        write (*,*) i,tid,tpid,' still running on ',myname
        write (cpid,'(I20)') tpid
        call clean(cmd)
        cmd='dc_killtask '//myname//' '//cpid//' TMP_dc_killtask'
        info=xeq(cmd)
      end if
      p=is(p+sadmch_next)
      goto 1
900   continue
C//END
      return
      end
