CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine sbox(aarg)
      character*(*) aarg
      write(*,110)
      write(*,*) aarg
      write(*,110)
110   format(70('-'))
      write(*,'(/)')
      return
      end

      subroutine header(aarg1,aarg2)
      character*(*) aarg1,aarg2

      write(*,130)
      write(*,110)
      write(*,110)
      write(*,121)aarg1
      write(*,121)aarg2
      write(*,110)
      write(*,110)
      write(*,130)
110   format(70('*'))
130   format(/)
120   format(/,20x,a,5x,i4,/)
121   format(/,20x,a,/)
 
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C connect two strings                         
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine sappend(s1,s2,s3)
      character*(*) s1
      character*(*) s2
      character*(*) s3
      integer i,k 
      CALL clean(s3)
      s3=' '
      k=0
      do i=1,len(s1)
         if(s1(i:i).ne.' ') then
            k=k+1
            s3(k:k)=s1(i:i)
         endif
      enddo
      do i=1,len(s2)
         if(s2(i:i).ne.' ') then
            k=k+1
            s3(k:k)=s2(i:i)
         endif
      enddo

      return
      end
      SUBROUTINE augnum(filename,name,number)
      IMPLICIT none
      CHARACTER*(*) filename,name
      INTEGER number
      INTEGER i,j,lf,ln
      CHARACTER*10 n8
      CALL clean(filename)
      lf=LEN(filename)
      ln=LEN(name)
      IF (ln+5.GT.lf)
     *  CALL errex('augnum: buffer length too small')
      CALL clean(filename)
      filename(1:ln)=name
      WRITE (n8,'(I010)') number
      DO j=1,10
      IF (n8(j:j).NE.' ') THEN
      ln=ln+1
      filename(ln:ln)=n8(j:j)
      ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE clean(c)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i
      DO i=1,LEN(c)
      c(i:i)=' '
      ENDDO
      RETURN
      END
      SUBROUTINE slen(c,n)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i,l,n
      l=LEN(c)
      DO i=1,l
      IF (c(i:i).EQ.' ') THEN
       n=i-1
       RETURN
      ENDIF
      ENDDO
      n=l
      RETURN
      END

      SUBROUTINE llen(c,n)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i,l,n
      l=LEN(c)
      DO i=l,1,-1
      IF (c(i:i).NE.' ') THEN
       n=i
       RETURN
      ENDIF
      ENDDO
      n=1
      RETURN
      END

C*********************************************************************

      integer function intgr(x,i,mx)
      implicit none
      integer i,j,k,mx,lf
      character*(*) x
      character*128 f

      do 3 j=1, mx
        if (x(j:j).ne.' ') goto 4
3     continue

      intgr=0
      return

4     continue
      do 1 i=j,mx
        if (x(i:i).gt.'9' .or. x(i:i) .lt. '0') goto 2
1     continue

      i=21
2     i=i-j
      if (i.eq.0) then
        intgr=0
        return
      endif

      call clean(f)
      write (f,100) i
      call skipblank(f)
100   format('(i',i2,')')
      if(j.le.0.or.j.ge.21) stop '** intgr: invalid value for j'
      read (x(j:20),f) k
      intgr=k
      return
      end

C*********************************************************************

      subroutine skipblank(iostring)

c skip any blanks in character string
c
c written by J. Neugebauer, 2004

      implicit none
      integer ls,i,io
      character*(*) iostring
      character*(255) istring

      call llen(iostring,ls)
      if(ls.gt.255) then
        stop '** skipblank: string too long'
      end if

      istring(1:ls)=iostring(1:ls)
      call clean(iostring)
      io=0
      do i=1,ls
        if(istring(i:i).ne.' ') then
          io=io+1
          iostring(io:io)=istring(i:i)
        end if
      end do

      end

C*********************************************************************

      SUBROUTINE SPLIT(X,ITEM,N)
      CHARACTER*(*) X
      CHARACTER*(*) ITEM(N)
      l=LEN(x)
      li=LEN(item(1))
      DO 90 I=1,N
      CALL CLEAN(ITEM(I))
90    CONTINUE
      I=0
      IT=0
1     I=I+1
      IF (I.GT.L) GOTO 999
      IF (X(I:I).NE.' ') GOTO 10
      GOTO 1
10    IT=IT+1
      IF (IT.EQ.N) THEN
      ITEM(IT)(1:li-I)=X(I:L)
      GOTO 999
      ENDIF
      J=0
11    J=J+1
      ITEM(IT)(J:J)=X(I:I)
      I=I+1
      IF (I.GT.L) GOTO 999
      IF (X(I:I).EQ.' ') THEN
      GOTO 1
      ENDIF
      GOTO 11
999   CONTINUE
      RETURN
      END

      INTEGER FUNCTION tmpxeq(cmd)
      IMPLICIT none
      INCLUDE 'param.h'
      CHARACTER*(*) cmd
      CHARACTER*255 cmdout
      INTEGER xeq
***   tmpxeq=xeq('. .profile; cd '//tempdir(1:lt)//'; '//cmd)
      CALL concat('cd ',tempdir(1:lt),cmdout)
      CALL appba(cmdout,'; ')
      CALL appba(cmdout,cmd)
      tmpxeq=xeq(cmdout)
      RETURN
      END

      integer function xeq(cmd)
      include 'defs.h'
      character*(*) cmd
      integer i,fsystem,l
      character*255 cbuf

      call clean(cbuf)
      call llen(cmd,l)
      cbuf(1:l)=cmd
      i=fsystem(l,cbuf)
      write (iosl,*) 'xeq[',i,'] ',cmd
      call flush(iosl)
      xeq=i
C+    xeq=0

      return
      end

      SUBROUTINE tosec(item,sec)
      IMPLICIT none
      CHARACTER*255 item(12)
      REAL*8 sec
      REAL*8 rr
      INTEGER i,intgr
      sec=0.D0
      IF (item(5).EQ.'seconds') THEN
       READ (item(4),'(D20.10)') sec
       RETURN
      ENDIF
      IF (item(5).EQ.'minutes') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(7),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      IF (item(5).EQ.'hours') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*3600.
       i=1
       rr=DFLOAT(intgr(item(6),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(9),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      IF (item(5).EQ.'days') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*86400.
       i=1
       rr=DFLOAT(intgr(item(6),i,20))
       sec=sec+rr*3600.
       i=1
       rr=DFLOAT(intgr(item(8),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(11),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      RETURN
      END

      subroutine prog_type(mode,prtype)
C
C returns type of program to be used for single points and
C type of calculation to be done for a given input value <mode>.
C if <mode> is unknown, the program will terminate.
C
C written by J. Neugebauer, Uni Erlangen, 2002.
C modified by C. Herrmann, Uni Jena 2005
C modified by S. Luber, ETH Zuerich, 2006
 
      implicit none
      integer maxmod,mode
      parameter(maxmod=5)
      character*10 prtype,catype,progtype(maxmod)
      data progtype /
     & 'TURBOMOLE ','DALTON    ','GAUSSIAN  ','ADF       ','MOLPRO    '/
      if(mode.ge.1.and.mode.le.maxmod) then
        prtype=progtype(mode)
      else
        write(*,'(a)') '** progtype: unknown program type'
        stop
      end if
      return
      end

************************************************************************

      subroutine calc_type(progno,calcno,catype)

C ======================================================================
C returns type of calculation to be done for a given input value <mode>.
C if <mode> is unknown, the program will terminate.
C
C written by J. Neugebauer, Uni Erlangen, 2002.
C modified by C. Herrmann, Uni Jena 2005
C modified by S. Luber, ETH Zuerich, 2006
C
C ----------------------------------------------------------------------
C NOTE: ALWAYS SYNCHRONIZE WITH calc_type (in snf/snf_tools.f90)
C       ALWAYS SYNCHRONIZE WITH FUNCTIONS ramanpos/vroapos
C       ALWAYS SYNCHRONIZE WITH FUNCTION  nfex
C ======================================================================
 
      implicit none
      integer maxprog,maxcalc,progno,calcno,i
      parameter(maxprog=5,maxcalc=10)
      character*10 catype,calctype(maxcalc,maxprog)
*----------------
* Turbomole types
*----------------
      data (calctype(i,1),i=1,maxcalc) /
     & 'DSCF      ','RIDFT     ','RIMP2     ','MPGRAD    ','EGRAD     ',
     & 'EGRAD/RI  ','RICC2     ','          ','          ','          '/
*-------------
* Dalton types   
*-------------
      data (calctype(i,2),i=1,maxcalc) /
     & 'SCF       ','MP2       ','CC2       ','CCS       ','CCSD      ',
     & 'MCSCF     ','SCF/TDHF  ','MP2/SOPPA ','DFT       ','          '/
*-------------
* Gaussian types
*-------------
      data (calctype(i,3),i=1,maxcalc) /
     & 'g98       ','g03       ','          ','          ','          ',
     & '          ','          ','          ','          ','          '/
*-------------
* ADF types
*-------------
      data (calctype(i,4),i=1,maxcalc) /
     & 'SCF       ','          ','          ','          ','          ',
     & '          ','          ','          ','          ','          '/
*-------------
* Molpro types
*-------------
      data (calctype(i,5),i=1,maxcalc) /
     & 'MCSCF     ','          ','          ','          ','          ',
     & '          ','          ','          ','          ','          '/
      if(progno.ge.1.and.progno.le.maxprog.and.calcno.ge.1.and.
     *   calcno.le.maxcalc) then
        catype=calctype(calcno,progno)
      else
        write(*,'(a)') '** calc_type: unknown calculation type'
        stop
      end if
      if(catype.eq.'          ') then
        write(*,'(a)') '** calc_type: unknown program type'
        call errex('unknown calculation type')
      end if
      end

      integer function nfex(progno,calcno,isuhf)
C------------------------------------------------------------------
C returns the value nfex="okok" for the given input value of mode
C (okok is the number of files to be copied to the slaves,
C written as a string of "1" entries, one for each file
C
C written by J. Neugebauer, Uni Erlangen, 2003
C modified by M. Reiher, Uni Bonn, April 2004
C modified by C. Herrmann, Uni Jena, April 2005
C modified by S. Luber, ETH Zuerich, June 2006
C------------------------------------------------------------------
      implicit none
      integer maxprog,maxcalc,progno,calcno,isuhf,i
      parameter(maxcalc=10,maxprog=5)
      integer nex(maxcalc,maxprog)
C------------------------------------------------------------------
C specific file numbers for the program types:
C------------------------------------------------------------------
      data (nex(i,1),i=1,10)/
     *   1111, 11111, 11111,  1111,  1111,
     *  11111, 11111,     0,     0,     0/
      data (nex(i,2),i=1,10)/
     *     11,    11,    11,    11,    11,
     *     11,    11,   111,    11,     0 /
      data (nex(i,3),i=1,10)/
     *      1,     1,     0,     0,     0,
     *      0,     0,     0,     0,     0/
      data (nex(i,4),i=1,10)/
     *      1,     0,     0,     0,     0,
     *      0,     0,     0,     0,     0/
      data (nex(i,5),i=1,10)/
     *      1,     0,     0,     0,     0,
     *      0,     0,     0,     0,     0/
c
      if(progno.ge.1.and.progno.le.maxprog.and.calcno.ge.1.and.
     *   calcno.le.maxcalc) then
        nfex=nex(calcno,progno)
      else
        nfex=0
        return
      end if
C-------------------------
C include snf_control file
C-------------------------
      nfex=nfex*10+1
      if(nfex.eq.0) return
      if(isuhf.gt.0) nfex=nfex*10+1
      end 

      subroutine ptime(sec,tbuf)
*
*     formatted output of time sec (in seconds)
*     in days, hours, minutes, and seconds
*
*     written by J. Neugebauer, Uni Erlangen, 2002
*
      implicit none
      integer y,sec,h,m,s,d,osec,unit,w
      character*132 tbuf
      call sec2hms(sec,y,w,d,h,m,s)
      if(y.gt.0) then
        write(tbuf,101) y,' years ',w,' weeks ',d,' days ',h,
     *  ' hours ',m,' minutes ',s,' seconds'
      else if(w.gt.0) then
        write(tbuf,100) w,' weeks ',d,' days ',h,' hours ',
     *   m,' minutes ',s,' seconds'
      else if(d.gt.0) then
        write(tbuf,100) d,' days ',h,' hours ',m,' minutes ',
     *   s,' seconds'
      else if(h.gt.0) then
        write(tbuf,100) h,' hours ',m,' minutes ',s,' seconds'
      else if(m.gt.0) then
        write(tbuf,100) m,' minutes ',s,' seconds'
      else
        write(tbuf,100) s,' seconds'
      end if
100   format(i2,5(a,i2))
101   format(i6,6(a,i2))
      end
 
      subroutine sec2hms(seci,y,w,d,h,m,s)
*
*     input : time in seconds
*     output: time in weeks, days, hours, minutes, seconds
*     (echter Sonnenumlauf: 365.242199 Tage)
*
*     1 year     = 31556952  seconds (Gregorianischer Kalender, 365.2425 days)
*     1 week     =   604800  seconds
*     1 day      =    86400  seconds
*     1 hour     =     3600  seconds
*     1 minute   =       60  seconds
*
*     written by J. Neugebauer, Uni Erlangen, 2002
*
      implicit none
      integer seci,h,m,s,d,osec,w,y
 
      osec=seci
      y=seci/31556952
      seci=seci-y*31556952
      w=seci/604800
      seci=seci-w*604800
      d=seci/86400
      seci=seci-d*86400
      h=seci/3600
      seci=seci-h*3600
      m=seci/60
      seci=seci-m*60
      s=seci
      seci=osec
      end
  

      SUBROUTINE snfdchead
      IMPLICIT none
      write(*,'(A)')
C        +1234567890123456789012345678+8765432109876543210987654321+
      write(*,'(A)')
     & ' +---------------------------------------------------------+'
      write(*,'(A)')
     & ' |                                                         |'
      write(*,'(A)')
     & ' |                        S N F D C                        |'
      write(*,'(A)')
     & ' |                                                         |'
      write(*,'(A)')
     & ' |               J. Neugebauer, C. Herrmann,               |'
      write(*,'(A)')
     & ' |      S. Luber, C. Kind, B. A. Hess, and M. Reiher       |'
      write(*,'(A)')
     & ' |                                                         |'
      write(*,'(A)')
     & ' |         University of Erlangen, Egerlandstr. 3,         |'
      write(*,'(A)')
     & ' |                D-91058 Erlangen, Germany                |'
      write(*,'(A)')
     & ' |                       1999 - 2003,                      |'
      write(*,'(A)')
     & ' |           University of Bonn, Wegelerstr. 12,           |'
      write(*,'(A)')
     & ' |                  D-53115 Bonn, Germany                  |'
      write(*,'(A)')
     & ' |                       2004 - 2005,                      |'
      write(*,'(A)')
     & ' |        Theoretical Chemistry, University of Jena        |'
      write(*,'(A)')
     & ' |          Helmholtzweg 4, D-07743 Jena, Germany          |'
      write(*,'(A)')
     & ' |                       2005 - 2006,                      |'
      write(*,'(A)')
     & ' |   Laboratorium fuer Physikalische Chemie, ETH Zurich    |'
      write(*,'(A)')
     & ' |    Wolfgang-Pauli-Str. 10, 8093 Zurich, Switzerland     |'
      write(*,'(A)')
     & ' |                       2006 - 2007                       |'
      write(*,'(A)')
     & ' |                                                         |'
      write(*,'(A)')
     & ' +---------------------------------------------------------+'
C        +1234567890123456789012345678+8765432109876543210987654321+
      write(*,'(A)')
      RETURN
      END

************************************************************************

      function string2real(rw)
      implicit none
      character*(*) rw
      double precision zahl,string2real
      integer i,j,k,pos,upper,minus,lrw

      k=0
      zahl=0
      call llen(rw,lrw)
      upper=lrw
      pos=index(rw,'.')
      if (pos.EQ.0) pos=upper+1
      i=pos-1
      j=index('0123456789',rw(i:i))
      do while(j.ne.0)
         zahl=zahl+(j-1)*10.d0**k
         k=k+1
         i=i-1
         j=index('0123456789',rw(i:i))
      end do
      minus=i
      k=-1
      do i=pos+1,upper,1
         j=index('0123456789',rw(i:i))
         if (j.ne.0) then
            zahl=zahl+(j-1)*10.d0**(k)
            k=k-1
         end if
      end do
      if(index('-',rw(minus:minus)).EQ.1) zahl=-zahl
      string2real=zahl
      end

************************************************************************
      logical function valdtype(mode)
*
* true, if mode is an valid displacement type
*
* written by J. Neugebauer, Uni Erlangen, 2002
*
* valid displacement types:
*
*  1:   step size cstep in units of length; disp. along normal modes
*       (i.e. norm of cartesian displacement vector is equal to cstep)
*  2:   step size cstep in units of energy; disp. along normal modes
*       (i.e. step is selected such that the expected change in energy
*       [harmonic approximation] is equal to cstep => different cartesian
*       step sizes for different modes)
*  3:   step size cstep in units of length/sqrt(mass); disp. along normal
*       modes (i.e. step is simply performed by adding
*       cstep*(non-mass-weighted normal modes) to the equilibrium geometry)
*       cstep is equal for all normal modes
*
      implicit none
      integer mxmod,i
      parameter(mxmod=10)
      integer mode,valm(mxmod)
      data valm / 1,2,3,1,1,1,1,1,1,1 /
      valdtype=.false.
      do i=1,mxmod
        if(valm(i).eq.mode) then
          valdtype=.true.
          return
        end if
      end do
      end

