      program specplot
c-----------------------------------------------------------------------  
c   read in vibrational spectra from g98.out-file
c   print several spectra into one gnuplot-file 
c   read in and plot Raman and VROA spectra from snf.out 
c
c   Attention: Raw version.
c              Most options only available for one plotted spectrum.
c
c     Use ifort for subroutine write_gnuplot_file - 
c     otherwise, you may have to replace write(...) 'plot \' 
c     by write(...) 'plot \\'.
c
c 
c   written by C. Herrmann 
c   University of Bonn 2005 
c   University of Jena 2005-2006
c   ETH Zurich 2006
c   modified by S. Luber,
c   ETH Zurich 2006-2007
c
c   using parts of routines (write_xxx_data, write_gnuplot) 
c   from SNF by J. Neugebauer, Uni Erlangen, 2002
c
c   last change 31.01.2007 (CH)
c-----------------------------------------------------------------------
c
      implicit none 
c
      integer i,j,maxgout,maxfreq,lrewr,numfiles,unit,lyscale,lset
      integer im,ithick,ifile,lcf,ico,mxico,snfnumfiles,maxsnfout
      real*8 string2real, yscale,freqmin, freqmax,sclifac,peakwidth
      parameter(maxgout=20,maxfreq=500,unit=10,mxico=10,maxsnfout=20)
      real*8 minpw,maxpw,dumpw,pw(maxfreq),minrm,maxrm,ymin,ymax
      integer lgout(maxgout),info,system,numpeaks(maxgout),lsfreq
      integer ltitle,lleg(maxgout),ldchar, num,lscratch
      character(len=20) gout(maxgout),a,chfile,cpw,snfout(maxsnfout)
      character(len=2) rewr
      character(len=255) row,buf,snfname,pid,fname,adjustl,ccom(10)
      character(len=50) title,leg(maxgout),disp,scratch,gaulo,ylab
      character(len=20) charyscale,charfreq,setfreq,dispchar
      character(len=255) set,savename,bla,xlabel
      real*8 freq(maxfreq,maxgout),irint(maxfreq,maxgout),rwi,rhe
      real*8 tfreq(maxfreq,maxgout),tint(maxfreq,maxgout),tfreqmin
      real*8 tfreqmax,tmin,tmax,sumint,fmax,fmin,bsumint(maxfreq)
      real*8 wmax(maxfreq),wmin(maxfreq)
      integer lbuf,iunit,junit,lgl,lsn,lcpw,tnumpeaks,lsnfout(maxsnfout)
      logical ex,ali
      external adjustl
c----------------------------------------------------------------------
c standard values
c----------------------------------------------------------------------
      yscale=10.d0
CSL
      peakwidth = 15.d0
      disp='set nokey'
      do i = 1,maxgout
        leg(i)=' '
        lleg(i) = 1
      end do
      gaulo='gauss_spectrum.dat'
      call llen(gaulo,lgl)
      ali=.false.
      sclifac = 1.0d0
      do i = 1,maxfreq
        pw(i) = peakwidth
        wmin(i)=0.0d0
        wmax(i)=0.0d0
      end do
      ithick=2
      rwi=1.d0
      rhe=1.d0
      ymin = 0.d0
      ymax = 0.d0
      title=''
      ltitle=0
      numfiles=1
      snfnumfiles=1
      ylab=''
      xlabel=''
      ico=1
      do i=1,mxico
        ccom(i) = ''
      end do
c-----------------------------------------------------------------------
c  write header
c-----------------------------------------------------------------------
CCH      call header
c
c-----------------------------------------------------------------------
c  user menu
c-----------------------------------------------------------------------
5     write(*,*) ' '
      write(*,*) '    Please choose one of the following options:'
      write(*,*) '    [g]plot : plot all g98* files in the working'
      write(*,*) '              directory into one ps-file'
      write(*,*) '    [v]roa  : plot VROA and Raman data contained in '
      write(*,*) '              snf.out '
      write(*,*) '              --> assure that file vroaplot_control'
      write(*,*) '              is present'
      write(*,*) '              (DEFAULT)'
      write(*,*) '    [h]elp  : print help'
      write(*,*) '    [q]uit '
      write(*,*) ' '
      read(*,'(a)') buf
      call slen(buf,lbuf)
      if(buf(1:1).eq.'v') then
c      if(buf(1:1).eq.'v'.or.lbuf.eq.0) then
c        inquire(exist=ex,file='snf.out')
c        if(.not.ex) then
c            write(*,*) ''
c            write(*,*) ' ** ERROR: snf.out not found'
c            write(*,*) ''
c            goto 5
c        else
c          snfname='snf.out'
c        end if
        info=system('ls -1 snf* > liste')
        open(unit=iunit,file='liste')
        i=1
6       read(iunit,'(a)',end=7) snfout(i)
        call llen(snfout(i),lsnfout(i))
        i=i+1
        goto 6
7       continue
        close(iunit)
C        info=system('rm liste')
        numfiles=i-1
        call readsnfout(numfiles,snfout,lsnfout,freq,irint,
     *  numpeaks,freqmin,freqmax,maxfreq)
      else if(buf(1:1).eq.'g') then
        info=system('ls -1 g98* > liste')
        open(unit=iunit,file='liste')
        i=1
10      read(iunit,'(a)',end=15) gout(i)        
        call llen(gout(i),lgout(i))
        i=i+1
        goto 10
15      continue
        close(iunit) 
C        info=system('rm liste')
        numfiles=i-1
        call readgout(numfiles,gout,lgout,freq,irint,numpeaks,freqmin,
     *  freqmax)
        title='Infrared spectra'
        ltitle=16
        ylab='Absorption coefficient [km/mol]'
      else if(buf(1:1).eq.'h') then
        write(*,*)
        write(*,*) ' vroa: requires file vroaplot_control'
        write(*,*) '       which must contain:'
        write(*,*) '       laser wavelength in format xxx.xx'
        write(*,*) '       total number of peaks to be plotted'
        write(*,*) '       list of peaks to be plotted,'
        write(*,*) '       e.g. 1,4-7,20'
        write(*,*) '       $vroa or $raman'
        write(*,*) '       (one line per entry)'
        write(*,*)
        write(*,*) '       (<Enter> = back to menu)'
        write(*,*)
        read(*,'(a)') bla 
        goto 5
      else if(buf(1:1).eq.'q') then
        stop
      end if
c 
c-----------------------------------------------------------------------
c  generate initial gaussian, Lorentzian, and line data
c-----------------------------------------------------------------------
      freqmax=freqmax+100.0d0
      freqmin=freqmin-100.0d0
      call write_gauss_data(freq,irint,numpeaks,freqmax,freqmin,
     *numfiles,yscale,sclifac,peakwidth,maxfreq)
      call write_lorentz_data(freq,irint,numpeaks,freqmax,freqmin,
     *numfiles,yscale,sclifac,pw,maxfreq)
      call write_line_data(freq,irint,numpeaks,freqmax,freqmin,
     *numfiles,yscale,sclifac,maxfreq)
      call write_rect_data(freq,irint,numpeaks,freqmax,freqmin,
     *         numfiles,yscale,sclifac,maxfreq,wmax,wmin,bsumint)
c
c-----------------------------------------------------------------------
c  create initial gnuplot file
c-----------------------------------------------------------------------
      inquire(file='input.gpin',exist=ex)
c-----------------------------------------------------------------------
c  shall the settings in existing input.gpin be used?
CCH    ************************
CCH       UNDER CONSTRUCTION!
CCH    ************************
c-----------------------------------------------------------------------
CCH      if(ex) then
CCH        write(*,*) ' gnuplot input file input.gpin already exists.'
CCH        write(*,*) ' shall the settings be used? [y/n]'
CCH        write(*,*) ' (default = yes)'
CCH        read(*,'(a)') set
CCH        call llen(set,lset)
CCH        if(lset.eq.1.and.set(1:1).eq.' ') set='y'
CCH        if(index(set,'y').ne.0) then
CCH          call readgpin(xlabel,ylab,xrange,yrange,) 
CCH          continue
CCH        else
          call write_gnuplot_file(freqmin,freqmax,numfiles,title,ltitle,
     *                        disp,leg,lleg,gaulo,ylab,ali,ithick,rwi,
     *                        rhe,ymin,ymax,xlabel,ccom,mxico)
CCH        end if
CCH      end if
c-----------------------------------------------------------------------
c  create initial eps file
c-----------------------------------------------------------------------
      write(*,*)
      write(*,'('' Generate spectra plots'')')
      write(*,'('' ----------------------'')')
      info = system('gnuplot input.gpin')
      info=system('gv -watch spectrum.eps&')
      write(*,*) ' '
c-----------------------------------------------------------------------
c  generate gaussian, Lorentzian, and line data
c-----------------------------------------------------------------------
170   call write_gauss_data(freq,irint,numpeaks,freqmax,freqmin,
     *numfiles,yscale,sclifac,peakwidth,maxfreq)
      call write_lorentz_data(freq,irint,numpeaks,freqmax,freqmin,
     *numfiles,yscale,sclifac,pw,maxfreq)
      call write_line_data(freq,irint,numpeaks,freqmax,freqmin,
     *numfiles,yscale,sclifac,maxfreq)
      call write_rect_data(freq,irint,numpeaks,freqmax,freqmin,
     *         numfiles,yscale,sclifac,maxfreq,wmax,wmin,bsumint)
c
c-----------------------------------------------------------------------
c  create gnuplot file
c-----------------------------------------------------------------------
180   call write_gnuplot_file(freqmin,freqmax,numfiles,title,ltitle,
     *                        disp,leg,lleg,gaulo,ylab,ali,ithick,rwi,
     *                        rhe,ymin,ymax,xlabel,ccom,mxico)
c-----------------------------------------------------------------------
c  create eps file
c-----------------------------------------------------------------------
190   write(*,*)
      write(*,'('' Generate spectra plots'')')
      write(*,'('' ----------------------'')')
      info = system('gnuplot input.gpin')
      goto 195
194   write(*,*) 'Sorry, syntax error!'
      write(*,*) 'please type <enter> to continue'
      read(*,*)
195   write(*,*) ''
      write(*,*)' The current plot of your spectra is just being shown.'
      write(*,*)' The following settings can be changed:'
      write(*,*)' [d]ist      :  distance between baselines '
      write(*,*)' [xr]ange    :  minimum and maximum frequency'
      write(*,*)' [ymin] <num>:  minimum intensity = <num>'
      write(*,*)' [ymax] <num>:  maximum intensity = <num>'
      write(*,*)' [tit]le     :  title'
      write(*,*)' [xl]<string>:  label of x-axis = <string>'
      write(*,*)' [yl]<string>:  label of y-axis = <string>'
      write(*,*)' [l]egends   :  legends of individual plots'
      write(*,*)' [gnu]plot   :  enter gnuplot commands'
      write(*,*)' [th] <int>  :  set thickness of lines to <int>'
      write(*,*)' [pg/plo/pli]:  plot Gaussian / Lorentzian /line data'
      write(*,*)' [ali]       :  add line spectrum to '
      write(*,*)'             :  Gaussian / Lorentzian plot'
      write(*,*)' [nali]      :  remove line spectrum '
      write(*,*)' [scli <num>]:  scale original line spectrum '
      write(*,*)'                by factor <num>'
      write(*,*)' [pw <num>]  :  use peakwidth = <num>'
      write(*,*)' [spw]       :  adjust peakwidth for selected region'
      write(*,*)' [rm] <a-b>  :  extinguish wavenumber range <a> to <b>' 
      write(*,*)' [re] <fname>  <a-b> : reread peaks in wavenumber'
      write(*,*)'                range <a> to <b> from file <fname>'
      write(*,*)' [wi] <num>  :  width of plot  = <num>'
      write(*,*)' [he] <num>  :  height of plot  = <num>'
      write(*,*)' [gr] <a-b>  :  group peaks in wavenumber range '
      write(*,*)'                <a> to <b>'
      write(*,*)' [sqgr]      :  group peaks in wavenumber range '
      write(*,*)'                <a> to <b> and plot them as rectangles'
      write(*,*)
      write(*,*)' Further options:'
      write(*,*)' ! <command> :  execute shell command <command>'
      write(*,*)' [pr] <int>  :  print list of freq.s and intensities'
      write(*,*)'                for <int>th file (default: file 1)'
      write(*,*)' [sa <file>] :  save spectrum as file.eps, file.gpin '
      write(*,*)'                and file.dat'
      write(*,*)' [su] <a>-<b>:  print sum of intensities of all peaks' 
      write(*,*)'                in wavenumber range <a> to <b>'
      write(*,*)' <quit>     :  quit without changes'
      write(*,*)' '
      read(*,'(a)') set
      call llen(set,lset)
      if(set(1:4).eq.'quit') then
        goto 201
      else if(set(1:1).eq.'d') then
        write(*,*)' '
        write(*,*)' The actual distance parameter is ',yscale 
        write(*,*)' Which parameter would you like to choose?'
        write(*,*)' (A larger parameter will increase the distance)'
        write(*,*)' (<Enter> = go back to settings menu)'
        write(*,*)' '
        read(*,'(a)') charyscale
        call llen(charyscale,lyscale)
        if(lyscale.eq.1) then
          goto 195
        else
        yscale=string2real(charyscale)
        write(*,*)' '
        write(*,*)' Distance parameter set to ',yscale
        write(*,*)' '
        goto 170 
        end if
      else if(set(1:3).eq.'gnu') then
196     write(*,*) ' you can enter up to 10 gnuplot commands which'
        write(*,*) ' will be written directly to the gnuplot file.'
        write(*,*) ' please enter your command'
        write(*,*) ' (<enter> = go back to main menu)'
        read(*,'(a)') set
        call llen(set,lset)
        if(lset.eq.1) goto 180
        ccom(ico) = set(1:lset)
        ico=ico+1
        goto 196
      else if(set(1:1).eq.'!') then
        info = system(set(2:255))
        goto 195
      else if(set(1:2).eq.'gr') then
        im = index(set,'-')
        read(set(3:im-1),*) fmin
        read(set(im+1:255),*) fmax
        call group(freq,irint,maxfreq,numpeaks,fmax,fmin) 
        goto 170
      else if(set(1:4).eq.'sqgr') then
        gaulo='rect_spectrum.dat'
        call readspcontrol(wmin,wmax,maxfreq)
        do j=1,maxfreq
        bsumint(j)=0.0d0
          do i=1,numpeaks(1)
            if(freq(i,1).le.wmax(j)+1.d0.and.freq(i,1).ge.wmin(j)-1.d0)
     *      bsumint(j)=bsumint(j)+irint(i,1)/(wmax(j)-wmin(j))
          end do
        end do
        goto 170
      else if(set(1:4).eq.'ymin') then
        read(set(5:255),*,end=194) ymin
        goto 180
      else if(set(1:4).eq.'ymax') then
        read(set(5:255),*,end=194) ymax
        goto 180
      else if(set(1:2).eq.'xl') then
        xlabel=adjustl(set(3:255))
      else if(set(1:2).eq.'yl') then
        ylab=adjustl(set(3:255))
      else if(set(1:2).eq.'xr') then
198     write(*,*)' '
        write(*,*)' The actual frequency range is ',freqmin,
     *               ' to ',freqmax,'cm^(-1).'
        write(*,*)' You can change <freqmax> and <freqmin>' 
        write(*,*)' by the following commands:'
        write(*,*)'        max <freqmax>'
        write(*,*)'        min <freqmin>'
        write(*,*)' (<Enter> = go back to settings menu)'
        write(*,*)' '
        read(*,'(a)') setfreq
        call slen(setfreq,lsfreq)
        if (lsfreq.eq.0) then
         goto 195 
        else if(setfreq(1:3).eq.'max') then 
         read(setfreq(4:20),'(A)',end=194) charfreq
         freqmax=string2real(charfreq)
          write(*,*)' '
          write(*,*)' The new frequency range is ',freqmin,
     *               ' to ',freqmax,'cm^(-1).'
          write(*,*)' '
          call write_gauss_data(freq,irint,numpeaks,freqmax,freqmin,
     *    numfiles,yscale,sclifac,peakwidth,maxfreq)
          call write_lorentz_data(freq,irint,numpeaks,freqmax,freqmin,
     *    numfiles,yscale,sclifac,pw,maxfreq)
          call write_gnuplot_file(freqmin,freqmax,numfiles,title,ltitle,
     *                        disp,leg,lleg,gaulo,ylab,ali,ithick,rwi,
     *                        rhe,ymin,ymax,xlabel,ccom,mxico)
          call write_line_data(freq,irint,numpeaks,freqmax,freqmin,
     *         numfiles,yscale,sclifac,maxfreq)
          call write_rect_data(freq,irint,numpeaks,freqmax,freqmin,
     *         numfiles,yscale,sclifac,maxfreq,wmax,wmin,bsumint)
          write(*,*)
          write(*,'('' Generate spectra plots'')')
          write(*,'('' ----------------------'')')
          info = system('gnuplot input.gpin')
          goto 198
        else if(setfreq(1:3).eq.'min') then
         read(setfreq(4:20),'(A)',end=194) charfreq
         freqmin=string2real(charfreq)
          write(*,*)' '
          write(*,*)' The new frequency range is ',freqmin,
     *               ' to ',freqmax,'cm^(-1).'
          write(*,*)' '
          call write_gauss_data(freq,irint,numpeaks,freqmax,freqmin,
     *    numfiles,yscale,sclifac,peakwidth,maxfreq)
          call write_lorentz_data(freq,irint,numpeaks,freqmax,freqmin,
     *    numfiles,yscale,sclifac,pw,maxfreq)
          call write_gnuplot_file(freqmin,freqmax,numfiles,title,ltitle,
     *                        disp,leg,lleg,gaulo,ylab,ali,ithick,rwi,
     *                        rhe,ymin,ymax,xlabel,ccom,mxico)
          write(*,*)
          write(*,'('' Generate spectra plots'')')
          write(*,'('' ----------------------'')')
          info = system('gnuplot input.gpin')
          goto 198
        else
          write(*,*)' '
          write(*,*)' Unknown command. Try again.'
          write(*,*)' '
          goto 198
        end if
      else if(set(1:2).eq.'re') then
        snfnumfiles=1
C        maxsnfout=1
        im=index(set,'-') 
        read(set(3:im-1),*,end=194) fname,tmin
        read(set(im+1:255),*,end=194) tmax
        fname=adjustl(fname)
        write(*,*) ' Attention: currently has to be same file'
        write(*,*) ' as the one already in use'
        write(*,*) 
CCH        write(*,*) ' How many modes are listed in this file?'
CCH        read(*,*) tnumpeaks
C        snfout=fname
        call llen(fname,lsnfout)
        call readsnfout(snfnumfiles,fname,lsnfout,tfreq,tint,
     *  tnumpeaks,tfreqmin,tfreqmax,maxfreq)
        do i=1,tnumpeaks
          if(tfreq(i,1).le.tmax.and.tfreq(i,1).ge.tmin.and.
     *       int(tfreq(i,1)*10.d0).eq.int(freq(i,1)*10.d0)) then
            irint(i,1) = tint(i,1)
          end if
        end do
        goto 170
      else if(set(1:3).eq.'plo') then
        gaulo='lorentz_spectrum.dat'
        goto 180
      else if(set(1:3).eq.'pli') then
        gaulo='line_spectrum.dat'
        goto 180
      else if(set(1:2).eq.'pg') then
        gaulo='gauss_spectrum.dat'
        goto 180
      else if(set(1:4).eq.'nali') then
        ali=.false.
        goto 180
      else if(set(1:4).eq.'scli') then
        read(set(5:255),*,end=194) sclifac
        goto 170
      else if(set(1:3).eq.'ali') then
        ali=.true.
        goto 180
      else if(set(1:2).eq.'pw') then
        read(set(3:255),'(a)',end=194) cpw
        call llen(cpw,lcpw)
        if(lcpw.eq.1) then
          write(*,*) ' Sorry, you did not specify and peakwidth...'
          write(*,*) ' please type <enter> to continue'
          read(*,*)
          goto 180
        else
          read(set(3:255),*,end=194) peakwidth
          do i = 1,maxfreq
            pw(i)=peakwidth
          end do
          goto 170
        end if
      else if(set(1:3).eq.'spw') then
        write(*,*) 
        write(*,*) ' Within which wavenumber range would you like '
        write(*,*) ' to adjust the peakwidth? (<min> - <max>,'
        write(*,*) ' e.g. 1000.00 - 1200.00'
        write(*,*)
        read(*,'(a)') set 
        im = index(set,'-')
        read(set(1:im-1),*,end=194) minpw
        read(set(im+1:255),*,end=194) maxpw
        write(*,*)
        write(*,*) ' which peakwidth?'
        write(*,*)
        read(*,*) dumpw
        do i = 1,numpeaks(1)
          if(freq(i,1).ge.minpw.and.(freq(i,1).le.maxpw)) pw(i)=dumpw
        end do
        goto 170
      else if(set(1:2).eq.'th') then
        read(set(3:255),*,end=194) ithick
        goto 180
      else if(set(1:2).eq.'rm') then
        im = index(set,'-')
        read(set(3:im-1),*,end=194) minrm
        read(set(im+1:255),*,end=194) maxrm
        do i = 1,numpeaks(1)
          if(freq(i,1).ge.minrm.and.(freq(i,1).le.maxrm)) 
     *    irint(i,1)=0.d0
        end do
        goto 170
      else if(set(1:2).eq.'wi') then
        read(set(3:255),*,end=194) rwi 
        goto 180
      else if(set(1:2).eq.'he') then
        read(set(3:255),*,end=194) rhe
        goto 180
      else if(set(1:2).eq.'pr') then
        read(set(3:255),'(a)',end=194) chfile
        call llen(chfile,lcf)
        if(lcf.eq.1) then
          ifile=1
        else
          read(set(3:255),*,end=194) ifile
        end if
        call freqplot(freq,irint,numpeaks,maxfreq,maxgout,ifile)
        write(*,*)
        write(*,*) ' type <enter> to continue'
        read(*,'(a)') set
        goto 180
      else if(set(1:2).eq.'sa') then
        read (set(3:255),'(a)') savename
        call llen(savename,lsn)
        call llen(gaulo,lgl)
        info=system('cp spectrum.eps '//savename(1:lsn)//'.eps')
        info=system('cp input.gpin '//savename(1:lsn)//'.gpin')
        info=system('cp '//gaulo(1:lgl)//' '//savename(1:lsn)//'.dat')
        goto 195
      else if(set(1:2).eq.'su') then
        im=index(set,'-')
        read(set(3:im-1),*,end=194) fmin
        read(set(im+1:255),*,end=194) fmax 
        sumint=0.0d0
        do i=1,numpeaks(1)
          if(freq(i,1).le.fmax.and.freq(i,1).ge.fmin) 
     *    sumint=sumint+irint(i,1)
        end do
        write(*,*) 
        write(*,*) ' wavenr. range     |  sum of intensities '
        write(*,*) ' ----------------------------------------' 
        write(*,'(2x,f7.2,a3,f7.2,a2,f10.4)') fmin,' - ',fmax,'|',sumint
        write(*,*)
        write(*,*) 'type <enter> to continue'
        read(*,*)
        goto 180
      else if(set(1:2).eq.'ti') then
        write(*,*)' '
        write(*,*)' The actual title is "'//title(1:ltitle)//'".'
        write(*,*)' You can change it by the following commands:'
        write(*,*)'  <newtitle>  : set title to <newtitle>'
        write(*,*)'   no         : delete title'
        write(*,*)'  <Enter>     : go back to settings menu'
        write(*,*)' '
        read(*,'(a)') title
        call llen(title,ltitle)
        if(ltitle.eq.1) then
          goto 195
        else if(title(1:2).eq.'no'.and.ltitle.eq.2) then
          title = ''
          goto 180
        else
          goto 180
        end if
      else if(set(1:1).eq.'l') then
199    write(*,*)' '
       write(*,*)' '
       write(*,*)' Do you want to display legends for each spectrum?'
       write(*,*)' [y]es       : yes, of course!'
       write(*,*)' [n]o        : no, please not!'
       write(*,*)' <Enter>     : go back to settings menu'
       read(*,'(a)') dispchar
       call llen(dispchar,ldchar)
       if(dispchar(1:1).eq.'n') then  
         disp = 'set nokey'  
         goto 195  
       else if(dispchar(1:1).eq.'y') then
         disp = 'set key Left'
1000     write(*,*)' '
         write(*,*)' <num> <leg> : set legend for the <num>th spectrum' 
         write(*,*)'               from below to <leg>'
         write(*,*)' <Enter>     : go back to legend menu'
         write(*,*)' '
         read(*,'(a)') scratch
         call llen(scratch,lscratch)
         if(lscratch.eq.1) then
           goto 199 
         else
           read(scratch,*) num,leg(num)
           call llen(leg(num),lleg(num))
      call write_gnuplot_file(freqmin,freqmax,numfiles,title,ltitle,
     *                        disp,leg,lleg,gaulo,ylab,ali,ithick,rwi,
     *                        rhe,ymin,ymax,xlabel,ccom,mxico)
      write(*,*)
      write(*,'('' Generate spectra plots'')')
      write(*,'('' ----------------------'')')
      info = system('gnuplot input.gpin')
      info=system('gv -watch spectrum.eps&')
           goto 1000
         end if
       else if(ldchar.eq.1) then
         goto 195
       else
         write(*,*) ''
         write(*,*) ' Unknown command ... try again!'
         write(*,*) ''
         goto 199
       end if 
CH      else if(lset.eq.1.and.set(1:1).eq.' ') then
CH        goto 201
      else
        write(*,*) ''
        write(*,*) ' Unknown command ... try again!'
        write(*,*) ''
        goto 195
      end if
201   continue
      end program
************************************************************************
      subroutine write_gauss_data(freq,irint,numpeaks,freqmax,
     *freqmin,numfiles,yscale,sclifac,peakwidth,maxfreq)
c     
      implicit none
c
      integer maxfiles
      parameter(maxfiles=10)
      integer numfiles,numpeaks(maxfiles),dat,numpoints,i,j,mode
      real*8 peakwidth,yscale,sclifac
      integer maxfreq
      parameter(numpoints=10000,dat=10)
      real*8 freq(maxfreq,maxfiles)
      real*8 irint(maxfreq,maxfiles),lineval(numpoints,maxfiles)
      real*8 tmpfac,ir_val(numpoints,maxfiles)
      real*8 gamma,alpha,fac2p,increment,freqmax,freqmin,xval      
      gamma=0.5d0*peakwidth/sqrt(2.0d0*log(2.0d0))
      alpha=1.d0/(2.0d0*gamma**2)
      fac2p=1.d0/sqrt(4.0d0*acos(0.d0))
CCHc  add some space to the left and the right of the spectrum
CCH      freqmax=freqmax+5*peakwidth 
CCH      freqmin=max(0.d0,freqmin-5*peakwidth)     
      increment=(freqmax-freqmin)/dble(numpoints-1)
      open (unit=dat,file='gauss_spectrum.dat',form='formatted')
      do j=1,numfiles
      Xval=freqmin
      do i=1,numpoints
        ir_val(i,j)=0.d0
        lineval(i,j) = 0.d0
        do mode=1,numpeaks(j)
          tmpfac=exp(-alpha*(xval-freq(mode,j))**2)
          ir_val(i,j)=ir_val(i,j)+irint(mode,j)*tmpfac
        if(int(xval*10.d0).eq.int(freq(mode,j)*10.d0)) lineval(i,j) =
     *                                     sclifac*irint(mode,j)
        enddo
C        ir_val(i,j)=ir_val(i,j)
        ir_val(i,j)=ir_val(i,j)+(j-1)*yscale
       xval=xval+increment
      enddo
      end do
       xval=freqmin
      do i=1,numpoints
       write(dat,'(5f14.7,3x)') 
     *  xval,(fac2p/gamma*ir_val(i,j),j=1,numfiles),
     *  (lineval(i,j),j=1,numfiles)
       xval=xval+increment
      end do
      close(dat)
      write(*,'(''   Created gnuplot data file  : '',A)')'gauss_spectrum
     *.dat'
      end subroutine
************************************************************************
      subroutine write_line_data(freq,irint,numpeaks,freqmax,
     *freqmin,numfiles,yscale,sclifac,maxfreq)
c
c  attention: only works for one plotted spectrum
c
      implicit none
c
      integer numfiles,numpeaks(numfiles),dat,i,j,mode
      real*8 yscale,pi,sclifac
      integer maxfreq
      parameter(dat=10)
      parameter(pi=3.1415926535897932384626433832795029d0)
      real*8 freq(maxfreq,numfiles)
      real*8 irint(maxfreq,numfiles)
      real*8 gamma,alpha,fac2p,freqmax,freqmin,xval
      open (unit=dat,file='line_spectrum.dat',form='formatted')
      xval=freqmin
      write(dat,*) freqmin,0.d0
      do i=1,numpeaks(1)
       write(dat,*) freq(i,1),0.d0
       write(dat,*) freq(i,1),sclifac*irint(i,1)
       write(dat,*) freq(i,1),0.d0
      end do
      write(dat,*) freqmax,0.d0
      close(dat)
      write(*,'(''   Created gnuplot data file  : '',A)')
     *'lorentz_spectrum.dat'
      end subroutine
************************************************************************
      subroutine write_lorentz_data(freq,irint,numpeaks,freqmax,
     *freqmin,numfiles,yscale,sclifac,pw,maxfreq)
c
      implicit none
c
      integer maxfiles
      parameter(maxfiles=10)
      integer maxfreq
      integer numfiles,numpeaks(maxfiles),dat,numpoints,i,j,mode
      real*8 peakwidth,yscale,pi,sclifac,pw(maxfreq),rtest
      parameter(numpoints = 10000,dat=10)
      parameter(pi=3.1415926535897932384626433832795029d0)
      real*8 freq(maxfreq,maxfiles)
      real*8 irint(maxfreq,maxfiles),lineval(numpoints,maxfiles)
      real*8 tmpfac,ir_val(numpoints,maxfiles)
      real*8 gamma(numpoints),alpha(numpoints)
      real*8 fac2p,increment,freqmax,freqmin,xval
      fac2p=0.5d0/pi
CCHc  add some space to the left and the right of the spectrum
CCH      freqmax=freqmax+5*peakwidth
CCH      freqmin=max(0.d0,freqmin-5*peakwidth)
      increment=(freqmax-freqmin)/dble(numpoints-1)
      open (unit=dat,file='lorentz_spectrum.dat',form='formatted')
      do j=1,numfiles
        xval=freqmin
        do i=1,numpoints
          ir_val(i,j)=0.d0
          lineval(i,j) = 0.d0
          do mode=1,numpeaks(j)
            gamma(i)=pw(mode)
            alpha(i)=gamma(i)/2.0d0
            tmpfac=1.0d0/((xval-freq(mode,j))**2+alpha(i)**2)
            ir_val(i,j)=ir_val(i,j)+irint(mode,j)*tmpfac
            if(int(xval*10.d0).eq.int(freq(mode,j)*10.d0)) 
     *      lineval(i,j) = sclifac*irint(mode,j)
          enddo
          ir_val(i,j)=ir_val(i,j)+(j-1)*yscale
         xval=xval+increment
        enddo
      end do
       xval=freqmin
       do i=1,numpoints
       write(dat,*) xval,(fac2p*gamma(i)*ir_val(i,j),j=1,numfiles),
     * (lineval(i,j),j=1,numfiles)
       xval=xval+increment
      end do
      close(dat)
      write(*,'(''   Created gnuplot data file  : '',A)')
     *'lorentz_spectrum.dat'
      end subroutine
************************************************************************
      subroutine write_gnuplot_file(freqmin,freqmax,numfiles,title,
     *ltitle,disp,leg,lleg,gaulo,ylab,ali,ithick,rwi,rhe,ymin,ymax,
     *xlab,ccom,mxico)
c
CCH   Use ifort for this routine - otherwise,
CCH   '\' may have to be replaced by '\\'
c
      implicit none
c
      integer gpin,numfiles,i,ltitle,lleg(numfiles),lgl,lyl,ithick,lxl
      real*8 freqmin,freqmax,rwi,rhe,ymin,ymax
      integer mxico,lco
      character(len=50) title,disp,leg(numfiles),gaulo,ylab
      character(len=255) xlab,ccom(mxico)
      parameter(gpin=10)
      logical ali
      call llen(gaulo,lgl)
      call llen(ylab,lyl)
      call llen(xlab,lxl)
      open (unit=gpin,file='input.gpin',form='formatted')
      write(gpin,*)'set term postscript color'
      write(gpin,*)'set term postscript eps'
      write(gpin,*)'set output "spectrum.eps"'
      write(gpin,*) disp
      write(gpin,*)'set title "'//title(1:ltitle)//'"'
      write(gpin,*)'set xrange [',freqmin,':',freqmax,']'
      if(ymin.ne.0.d0.or.ymax.ne.0.d0) 
     *    write(gpin,*)'set yrange [',ymin,':',ymax,']'
      write(gpin,*)'set ylabel "'//ylab(1:lyl)//'"'
      write(gpin,*)'set xlabel "'//xlab(1:lxl)//'"'
      write(gpin,*)' set size ',rwi,',',rhe
      do i=1,mxico
        call llen(ccom(i),lco)
        if(lco.gt.1) write(gpin,*) ccom(i)(1:lco)
      end do
      write(gpin,*) 'plot \'
      do i=1,numfiles-1
      write(gpin,*)'"'//gaulo(1:lgl)//'"  u 1:',i+1,'t '
     *//'"'//leg(i)(1:lleg(i))//'"'//' w l lw ',ithick ,', \'   
      if(ali) write(gpin,*)'"line_spectrum.dat" u 1:',i+1,'t '
     *//'"'//leg(i)(1:lleg(i))//'"'//' w l lw 1 ,\'
      end do
      i=numfiles
      if(.not.ali) then
        write(gpin,*)'"'//gaulo(1:lgl)//'"  u 1:',i+1,' t '
     *  //'"'//leg(i)(1:lleg(i))//'"'//' w l lw ',ithick
      else
        write(gpin,*)'"'//gaulo(1:lgl)//'"  u 1:',i+1,' t '
     *  //'"'//leg(i)(1:lleg(i))//'"'//' w l lw ',ithick,', \'
        write(gpin,*)'"line_spectrum.dat" u 1:',i+1,'t '
     *  //'"'//leg(i)(1:lleg(i))//'"'//' w l lw 1'
      end if
10    format(a26,i2,a12,a20,a2)
      close(gpin)
      write(*,'(''   Created gnuplot input file : '',A)') 'input.gpin'
      end subroutine
************************************************************************
      SUBROUTINE llen(c,n)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i,l,n
      l=LEN(c)
      DO i=l,1,-1
      IF (c(i:i).NE.' ') THEN
       n=i
       RETURN
      ENDIF
      ENDDO
      n=1
      RETURN
      END
************************************************************************

      function string2real(rw)
      implicit none
      character(len=*) rw
      real*8 zahl,string2real
      integer i,j,k,pos,upper,minus,lrw

      k=0
      zahl=0
      call llen(rw,lrw)
      upper=lrw
      pos=index(rw,'.')
      if (pos.EQ.0) pos=upper+1
      i=pos-1
      j=index('0123456789',rw(i:i))
      do while(j.ne.0)
         zahl=zahl+(j-1)*10.d0**k
         k=k+1
         i=i-1
         j=index('0123456789',rw(i:i))
      end do
      minus=i
      k=-1
      do i=pos+1,upper,1
         j=index('0123456789',rw(i:i))
         if (j.ne.0) then
            zahl=zahl+(j-1)*10.d0**(k)
            k=k-1
         end if
      end do
      if(index('-',rw(minus:minus)).EQ.1) zahl=-zahl
      string2real=zahl
      end function string2real

c***********************************************************************
      subroutine header
      write(*,'(A)')
     * ' +----------------------------------------------------------+'
      write(*,'(A)')
     * ' |                                                          |'
      write(*,'(A)')
     * ' |                         SPECPLOT                         |'
      write(*,'(A)')
     * ' |                                                          |'
      write(*,'(A)')
     * ' |                            by                            |'
      write(*,'(A)')
     * ' |                                                          |'
      write(*,'(A)')
     * ' |                C. Herrmann and B. Le Guennic             |'
      write(*,'(A)')
     * ' |                                                          |'
      write(*,'(A)')
     * ' |                  University of Bonn, 2005                |'
      write(*,'(A)')
     * ' |                                                          |'
      write(*,'(A)')
     * ' +----------------------------------------------------------+'
      end subroutine

c***********************************************************************
c  read in frequencies and intensities from g98.out-files 
c-----------------------------------------------------------------------
      subroutine readgout(numfiles,gout,lgout,freq,irint,numpeaks,
     *freqmin,freqmax)
c
      implicit none
c
      integer i,j,maxgout,maxfreq,numfiles,unit
      real*8 freqmin, freqmax
      parameter(maxgout=20,maxfreq=500,unit=10)
      integer lgout(maxgout),numpeaks(maxgout)
      character(len=20) gout(maxgout),a
      character(len=80) row
      real*8 freq(maxfreq,maxgout),irint(maxfreq,maxgout)
c
      do i=1,numfiles
      j=1
      open(unit,file=gout(i)(1:lgout(i)),err=200)
20      read(unit,'(a80)',end=50) row
      if(row(1:6).eq.' Frequ') then
        read(row,30) a,freq(j,i),freq(j+1,i),freq(j+2,i)
        read(unit,'(a80)') row
        read(unit,'(a80)') row
        read(unit,'(a80)') row 
        read(row,40) a,irint(j,i),irint(j+1,i),irint(j+2,i) 
        read(unit,'(a80)') row
CCH     read(row,40) a,ramint(j,i),ramint(j+1,i),ramint(j+2,i) 
        j=j+3
        goto 20
      else
        goto 20
      end if
      close(unit)   
30    format(a16,3e19.1)
40    format(a16,3e19.1)
50    continue
      numpeaks(i)=j-1
      if(i.eq.1) then
        freqmin=freq(1,i)
        freqmax=freq(numpeaks(i),i)
      else
        freqmin=min(freq(1,i),freqmin)
        freqmax=max(freq(numpeaks(i),i),freqmax) 
      end if
      end do
      goto 201
200   write(*,*) '    Error: Could not open '//gout(i)
201   continue
      end subroutine
c
c***********************************************************************
c  read in frequencies and intensities from snf.out
c-----------------------------------------------------------------------
      subroutine readsnfout(snfnumfiles,snfout,lsnfout,
     *  freq,ramint,numpeaks,freqmin,freqmax,maxfreq)
c
      implicit none
c
      integer i,j,maxfreq,unit,snfnumfiles,z,maxsnfout,r,s,p
      real*8 freqmin, freqmax,blub
      parameter(unit=10,maxsnfout=200)
      integer numpeaks(maxsnfout),select(maxfreq),lsnfout(maxsnfout)
      character(len=255) row,snfname,selstring,bla,spectype
      character(len=6) laswl
      character(len=20) snfout(maxsnfout)
      real*8 freq(maxfreq,maxsnfout),ramint(maxfreq,maxsnfout)
      logical ex
c
      do i = 1,maxfreq
        select(i)=1
      end do
      inquire(exist=ex,file='vroaplot_control')
      if(.not.ex) then
        write(*,*) ' '
        write(*,*) '** ERROR: file vroaplot_control not found'
        write(*,*) ' '
        stop
      end if
      open(unit,file='vroaplot_control')
      read(unit,*) laswl
      read(unit,*) numpeaks(1)
      read(unit,'(a)',end=19) selstring
      call str2select(selstring,select,maxfreq)
      read(unit,'(a)',end=19) bla
      spectype='vroa'
      if(index(bla,'$raman').ne.0) then
        spectype='raman'
      end if
19    close(unit)
CSL      inquire(exist=ex,file=snfname)
c      if(.not.ex) then
c        write(*,*) ' '
c        write(*,*) '** ERROR: file '//snfname//' not found'
c        write(*,*) ' '
c        stop
c      end if
      do i=1,snfnumfiles
       numpeaks(i)=numpeaks(1)
      end do
      do z=1,snfnumfiles
      j=1
      open(unit,file=snfout(z)(1:lsnfout(z)),err=200)
CSL      open(unit,file=snfname,err=200)
20    read(unit,'(a80)',end=50) row
      if(spectype.eq.'vroa'.and.index(row,'Raman Optical').ne.0.and.
     *  index(row,laswl).ne.0) then
c---------------------------------------------
c read in backscattering intensity difference
c---------------------------------------------
30    read(unit,'(a80)',end=50) row
        if(index(row,'Difference').ne.0.and.
     *   index(row,'London').ne.0) then
          do s = 1,3
            read(unit,'(a80)') row
          end do
C         j=1
          do i = 1,numpeaks(z)
            read(unit,'(a80)') row
            if(select(i).eq.1) then
              read(row(9:20),*) freq(j,z)
              read(row(64:73),*) ramint(j,z)
              j=j+1
            end if
          end do
c          numpeaks(z)=j-1
          goto 50
         else
           goto 30
         end if
      else if(spectype.eq.'raman'.and.index(row,'Raman results').ne.0
     *  .and.index(row,laswl).ne.0) then
         do r = 1,9
           read(unit,'(a80)') row
         end do
            do i = 1,numpeaks(z)
            read(unit,'(a80)') row
            if(select(i).eq.1) then
              read(row(33:43),*) freq(j,z)
              read(row(47:60),*) ramint(j,z)
              write(*,*) 
              j=j+1
            end if
          end do
c          numpeaks=j-1
          goto 50
      else
        goto 20
      end if
      close(unit)
50    continue
C      close(unit)
C      numpeaks(i)=j-1
C      if(i.eq.1) then
C        freqmin=freq(1,i)
C        freqmax=freq(numpeaks(i),i)
C      else
C        freqmin=min(freq(1,i),freqmin)
C        freqmax=max(freq(numpeaks(i),i),freqmax)
C      end if
      end do
      numpeaks(1)=j-1
      freqmin=freq(1,1)
      freqmax=freq(numpeaks(1),1)
c
      goto 201
200   write(*,*) '    Error: Could not open '//snfout(i)
201   continue
c
      end subroutine
c**********************************************************
      SUBROUTINE slen(c,n)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i,l,n
      l=LEN(c)
      DO i=1,l
      IF (c(i:i).EQ.' ') THEN
       n=i-1
       RETURN
      ENDIF
      ENDDO
      n=l
      RETURN
      END
c***********************************************************************
      subroutine str2select(selstring,select,mxpar)
      integer mxpar,select(mxpar),istart,i,j,atom,fatom,latom,imin
      character*255 selstring,a,stk
      do i = 1, mxpar
        select(i) = 0
      end do
      istart=1
      do i=1,255
        read(selstring(i:i),'(a)') a
        if((a.eq.',').or.(i.eq.255)) then
          read(selstring(istart:i-1),'(a)') stk
          istart=i+1
          imin=index(stk,'-')
          if(imin.eq.0) then
            read(stk,*) atom
            select(atom)=1
          else
            read(stk(1:imin-1),*) fatom
            read(stk(imin+1:255),*) latom
            do j=fatom,latom
              select(j) = 1
            end do
          end if
        end if
      end do
      end subroutine str2select
c***********************************************************************
c
      subroutine freqplot(freq,irint,numpeaks,maxfreq,maxgout,ifile)
c
      implicit none
c
      integer numpeaks,maxfreq,maxgout,ifile,i
      real*8 freq(maxfreq,maxgout),irint(maxfreq,maxgout)      
c
      write(*,*)
      write(*,*)' ---------------------------------------------'
      write(*,*)'   mode nr. |  wavenr. / cm^-1  |  intensity'
      write(*,*)' ---------------------------------------------'
      do i=1,numpeaks
        write(*,'(i10,a4,f13.2,a7,f10.5)') i,'  |',freq(i,ifile),'  |',
     *                                     irint(i,ifile) 
      end do
      write(*,*)
      end subroutine
C************************************************************************

      function adjustl(row)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       reads row (character), writes row without blanks before
c       the text.
c
c       written by J. Neugebauer, 21.09.2001
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        implicit none
        character(len=*) row,adjustl
        integer i,ifirst
        adjustl=''
        ifirst=len(row)
        do i=1,len(row)
          if(row(i:i).ne.' ') then
            ifirst=i
            exit
          end if
        end do
        adjustl=row(ifirst:)
        return
        end function adjustl
c
C************************************************************************
c
      subroutine group(freq,irint,maxfreq,nummode,fmax,fmin)
c
      implicit none
c
      integer maxfreq,nummode,i,icount,ip
      real*8 freq(maxfreq),irint(maxfreq),meanfreq,intsum,fmax,fmin,sum
c
      meanfreq=0.0d0
      intsum=0.d0
      sum=0.d0
      icount=0
      ip=0
      do i=1,nummode
        if(freq(i).le.fmax.and.freq(i).ge.fmin) sum=sum+dabs(irint(i)) 
      end do
      do i=1,nummode
        if(freq(i).le.fmax.and.freq(i).ge.fmin) intsum=intsum+irint(i)
      end do
      do i=1,nummode
        if(freq(i).le.fmax.and.freq(i).ge.fmin) 
     *    meanfreq=meanfreq+freq(i)*dabs(irint(i))
      end do
      meanfreq=meanfreq/sum
      do i=1,nummode
        if(freq(i).le.fmax.and.freq(i).ge.fmin) then 
          ip=ip+1
          if(icount.eq.0) then
            freq(i)=meanfreq
            irint(i) = intsum
            icount=icount+1
          else
            freq(i)=0.d0
            irint(i) = 0.d0
          end if
        end if  
      end do
      write(*,*) 
      write(*,*)' grouped ',ip,' peaks in wavenumber range '
      write(*,*)  fmin,' cm^-1 to ',fmax,' cm^-1'
      write(*,*)' to peak centered at ',meanfreq,' cm^-1 '
      write(*,*)' with intensity equal to ', intsum 
      write(*,*) 
      write(*,*)' please type <enter> to continue' 
      read(*,*)
c
      end subroutine
c
c**************************************************************
c
      subroutine readspcontrol(wmin,wmax,maxfreq)
c
      implicit none
c
      integer maxfreq,iunit,i,j,im
      real*8 wmin(maxfreq),wmax(maxfreq)
      character(len=255) row
      parameter(iunit=20)
c
      open(unit=iunit,file='scontrol')
1     read(iunit,'(a)',end=100) row
      if(index(row,'range').ne.0) then
        do i=1,maxfreq
          read(iunit,'(a)',end=100) row
          if(index(row,'end').ne.0) goto 1
            im=index(row,'-')
            read(row(1:im-1),*,end=100) wmin(i)
            read(row(im+1:255),*,end=100) wmax(i)
        end do
      end if
CCH      if(index(row,'').ne.0) read(row(:255),)
      goto 1
100   close(iunit)
c
      end subroutine
c
***************************************************************
c
      subroutine write_rect_data(freq,irint,numpeaks,freqmax,freqmin,
     *         numfiles,yscale,sclifac,maxfreq,wmax,wmin,bsumint)
c
c  attention: only works for one plotted spectrum
c
      implicit none
c
      integer numfiles,numpeaks(numfiles),dat,i,j,mode
      real*8 yscale,sclifac
      integer maxfreq
      parameter(dat=10)
      real*8 freq(maxfreq,numfiles),wmax(maxfreq),wmin(maxfreq)
      real*8 irint(maxfreq,numfiles),bsumint(maxfreq)
      real*8 gamma,alpha,fac2p,freqmax,freqmin,xval
      open (unit=dat,file='rect_spectrum.dat',form='formatted')
      xval=freqmin
      write(dat,*) freqmin, 0.d0
      do i=1,maxfreq
       if(wmin(i).ne.0.and.wmax(i).ne.0) then
         write(dat,*) wmin(i),0.d0
         write(dat,*) wmin(i),bsumint(i)
         write(dat,*) wmax(i),bsumint(i)
         write(dat,*) wmax(i),0.d0
       end if
      end do
      write(dat,*) freqmax, 0.d0
      close(dat)
      write(*,'(''   Created gnuplot data file  : '',A)')
     *'rect_spectrum.dat'
c
      end subroutine
